<%@ LANGUAGE="VBSCRIPT" ENABLESESSIONSTATE = False %>

<%
'*****************************************************************
'CFR Project Home Page
'Copyright (c) 2001 Roger Jennings - All Rights Reserved
'This page has been validated with the W3C HTML Validation Service
'for XML well-formedness, but doesn't yet conform to XHTML strict
'*****************************************************************

Option Explicit
Dim lngTOCItems, lngSectItems, strTOCItems, strSectItems, strBothItems, strCFRURL, strSearchPage
'FTStats.inc has the items count for the CFRTOC and CFRSects catalogs
%>

<!--#include File="FTStats.inc" -->
<%
strCFRURL = Application("strCFRURL")
strTOCItems = FormatNumber(lngTOCItems, False, False, False, True)
strTOCItems = FormatNumber(lngSectItems, False, False, False, True)
strBothItems = FormatNumber(lngTOCItems + lngSectItems, False, False, False, True)
strSearchPage = strCFRURL & "results.asp"
%>

<?xml version="1.0" encoding = "UTF-8" ?>
<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en' >
   <head>
      <title>
      Home Page of the OakLeaf Systems U.S. Code of Federal Regulations Web Services
      </title>
      <link rel='stylesheet' href='CFRSect.css' type='text/css' />
   </head>
   <body>
      <table width='100%' border='0' cellpadding='0' cellspacing = '0' align='center'>
         <tr><td height='80px' width='70px' padding-left='0px' padding-right='0px'><img src='OakLeaf.gif' height='80px' width='70px' border='0' /></td><td>OakLeaf Systems<br />Online U.S. Code of Federal Regulations Delivered by<br />An XML Web Service from <i>Visual Basic.NET XML Web Services Developer's Guide</i><br />Osborne/McGraw-Hill ISBN 0-07-222369-3 (To be published in Spring 2002)
         </td></tr>
      </table>
      <table width='100%' border='0' align='center'>
         <th colspan='2'>Home Page for Access to the U.S. Code of Federal Regulations from the OakLeaf Systems Database</th>
         <tbody style='behavior:url(CFRToc.htc)' slColor='#d0d0d0' hlColor='#e8e8e8' txColor='#266294'>
            <tr id='tocHome' valign='center'><td>CONTENTS</td><td>Display the list of CFR Titles at the top level of the TOC (Click here to start)</td></tr>
            <tr id='search' valign='center'><td>SEARCH</td><td>Use full-text search to locate and display matching CFR sections and TOCs</td></tr>               
         </tbody>
         <tr id='noTag' class='HasSubs' valign='top'><td>Data Source</td><td>National Archives and Records Administration (NARA) Electronic CFR (eCFR Beta)</td></tr>
         <tr id='noTag' class='HasSubs' valign='top'><td>Disclaimer</td><td>The content of this site is not a legal version of the U.S. CFR  </td></tr>
         <tr id='noTag' class='HasSubs' valign='top'><td>Official Site</td><td><a href='http://www.access.gpo.gov/ecfr/'>Search Page for the Electronic Code of Federal Regulations</a> (eCFR Beta)</td></tr> 		
         <tr id='noTag' class='HasSubs' valign='top'><td>Site Status</td><td>Demonstration version 0.91 using Microsoft<sup>&#174;</sup> Visual Basic<sup>&#174;</sup> 6.0 ActiveX DLLs</td></tr>
         <tr id='noTag' class='HasSubs' valign='top'><td>Last Update</td><td>From NARA <a href='http://www.access.gpo.gov/nara/lsa/curlist.html'>Current List of CFR Parts Affected</a> of 10/2/2001</td></tr>
         <tr id='noTag' class='HasSubs' valign='top'><td>Database</td><td>840 MB with the full text of 165,000 sections; 125 MB in full-text catalogs</td></tr>
         <tr id='noTag' class='HasSubs' valign='top'><td>Search Engine</td><td>Microsoft<sup>&#174;</sup> SQL Server 2000<sup>TM</sup> Full-Text Search</td></tr>
<%
If lngTOCItems = 0 and lngSectItems = 0 Then
%>
         <tr id='noTag' class='HasSubs' valign='top'><td>Search Status</td><td>Full-Text Search Is Not Available</td></tr>
<%
ElseIf lngTOCItems = 1 and lngSectItems = 0 Then
%>
        <tr id='noTag' class='HasSubs' valign='top'><td>Search Status</td><td>Full-Text Search for Tables of Contents Only (<% Response.Write(strTOCItems) %> Elements)</td></tr>
<%
ElseIf lngTOCItems = 0 and lngSectItems = 1 Then
%>
        <tr id='noTag' class='HasSubs' valign='top'><td>Search Status</td><td>Full-Text Search for Section Text Only (<% Response.Write(strSectItems) %> Elements)</td></tr>
<%
Else
%>
        <tr id='noTag' class='HasSubs' valign='top'><td>Search Status</td><td>Full-Text Search for Tables of Contents and Section Text (<% Response.Write(strBothItems) %> Elements)</td></tr>
<%   
End If
%>
         <tbody style='behavior:url(CFRToc.htc)' slColor='#d0d0d0' hlColor='#e8e8e8' txColor='#266294'>
            <tr id='help' valign='center'><td>HELP</td><td>Get assistance with navigating the site and follow links to interesting sections</td></tr>
            <tr id='about' valign='center'><td>ABOUT</td><td>Learn about OakLeaf Systems' XML Web services</td></tr>
         </tbody>
      </table>
      <hr width='100%' color='#266294' align='center' />

      <!--#include File="DefaultText.htm" -->
      <!--#include File="Copyright.htm" -->

   </body>
</html>