VERSION 5.00
Begin VB.Form frmCFRClient 
   Caption         =   "Code of Federal Regulations (CFR) Contents and XML Data Documents"
   ClientHeight    =   7740
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9615
   Icon            =   "CFRClient.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7740
   ScaleWidth      =   9615
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkUpdates 
      Caption         =   "Updates"
      Height          =   195
      Left            =   120
      TabIndex        =   23
      ToolTipText     =   "Mark to check parts updated today"
      Top             =   6930
      Width           =   1095
   End
   Begin VB.CommandButton cmdClientForm 
      Caption         =   "Client Form"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   21
      ToolTipText     =   "Click to open the client emulator form to generate and display XHTML documents"
      Top             =   7200
      Width           =   1095
   End
   Begin VB.CheckBox chkGetDoc 
      Caption         =   "Reprocess Previously-Retrieved Section Document"
      Height          =   255
      Left            =   5280
      TabIndex        =   19
      Top             =   4290
      Width           =   3975
   End
   Begin VB.CheckBox chkAddSects 
      Caption         =   "Add Section Elements to Chapter Table of Contents (May be Slow)"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   4200
      TabIndex        =   16
      ToolTipText     =   "Expands the Chapter TOC to include Sections as an additional level under Parts (Can't be Halted)"
      Top             =   1950
      Visible         =   0   'False
      Width           =   5175
   End
   Begin VB.CheckBox chkAddParts 
      Caption         =   "Add Part Elements to Chapter Table of Contents"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   15
      ToolTipText     =   "Expands the Chapter TOC to include Parts under Chapter elements"
      Top             =   1950
      Width           =   3855
   End
   Begin VB.CheckBox chkAttribs 
      Caption         =   "Include Attributes in Each Element Tag"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1440
      TabIndex        =   14
      ToolTipText     =   "Displays attributes of TOC elements in the text box"
      Top             =   7230
      Width           =   3375
   End
   Begin VB.CommandButton cmdPartTOC 
      Caption         =   "Create XML TOC        (Part Level)"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3240
      TabIndex        =   13
      ToolTipText     =   "Creates a full TOC at the part level (slow)"
      Top             =   6630
      Width           =   1575
   End
   Begin VB.CommandButton cmdChapTOC 
      Caption         =   " Create XML TOC     (Chapter Level)"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   1440
      TabIndex        =   12
      ToolTipText     =   "Creates a full TOC at the chapter level"
      Top             =   6630
      Width           =   1575
   End
   Begin VB.ListBox lstSections 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1740
      ItemData        =   "CFRClient.frx":030A
      Left            =   5280
      List            =   "CFRClient.frx":030C
      Style           =   1  'Checkbox
      TabIndex        =   7
      ToolTipText     =   "Double-clicking a section displays the XML document (retrieves it if not in the database)"
      Top             =   2520
      Width           =   4215
   End
   Begin VB.ListBox lstParts 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1740
      ItemData        =   "CFRClient.frx":030E
      Left            =   120
      List            =   "CFRClient.frx":0310
      Style           =   1  'Checkbox
      TabIndex        =   6
      ToolTipText     =   "Double-clickng a Part item displays its sections and generates a part-level TOC"
      Top             =   2520
      Width           =   4935
   End
   Begin VB.ListBox lstChapters 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1530
      ItemData        =   "CFRClient.frx":0312
      Left            =   4200
      List            =   "CFRClient.frx":0314
      TabIndex        =   4
      ToolTipText     =   "Double-clickng a Chapter item displays its parts and generates a chapter-level TOC"
      Top             =   360
      Width           =   5295
   End
   Begin VB.ListBox lstTitles 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1530
      ItemData        =   "CFRClient.frx":0316
      Left            =   120
      List            =   "CFRClient.frx":0318
      TabIndex        =   3
      ToolTipText     =   "Double-clicking a Title item lists its chapters and generates a top-level TOC"
      Top             =   360
      Width           =   3855
   End
   Begin VB.TextBox txtDoc 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      ToolTipText     =   "Displays tables of contents or XML documents as text or in IE 5.5+"
      Top             =   4560
      Width           =   9375
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Click to connect to default (local) SQL Server 2000 instance"
      Top             =   6480
      Width           =   1095
   End
   Begin VB.Frame fraTOC 
      Caption         =   "Create Full Table of Contents"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   1320
      TabIndex        =   17
      Top             =   6360
      Width           =   3615
   End
   Begin VB.Frame fraBulkOps 
      Caption         =   "Bulk Operations"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   5040
      TabIndex        =   18
      Top             =   6360
      Width           =   4455
      Begin VB.CommandButton cmdHalt 
         Caption         =   "Halt Operation"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   1590
         TabIndex        =   27
         ToolTipText     =   "Halts any bulk operation at the end of the title being processed"
         Top             =   720
         Width           =   1400
      End
      Begin VB.CommandButton cmdGetAllDocs 
         Caption         =   "Get All Text"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   1590
         TabIndex        =   26
         ToolTipText     =   "Retrieves all missing section documents from the eCFR database"
         Top             =   240
         Width           =   1400
      End
      Begin VB.CommandButton cmdGetSects 
         Caption         =   "Get All Sections"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   100
         TabIndex        =   25
         ToolTipText     =   "Retrieves all missing parts and section items from the e-CFR database"
         Top             =   240
         Width           =   1400
      End
      Begin VB.CommandButton cmdUpdates 
         Caption         =   "Get Updates"
         Enabled         =   0   'False
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   100
         TabIndex        =   24
         ToolTipText     =   "Retrieves the section text for updated parts"
         Top             =   720
         Width           =   1400
      End
      Begin VB.CommandButton cmdParseErrors 
         Caption         =   "Process Errors"
         Enabled         =   0   'False
         Height          =   375
         Left            =   3060
         TabIndex        =   22
         Top             =   720
         Width           =   1300
      End
      Begin VB.CommandButton cmdStoreTOCs 
         Caption         =   "Add All TOCs"
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   3060
         TabIndex        =   20
         ToolTipText     =   "Generates TOCs for titles, chapters, and parts"
         Top             =   240
         Width           =   1300
      End
   End
   Begin VB.CommandButton cmdTables 
      Caption         =   "Generate Tables"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5160
      TabIndex        =   1
      Top             =   7080
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.Label lblDoc 
      Caption         =   "XML TOC or Section Document - Double-click to Open in IE 5.5+"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   4320
      Width           =   4935
   End
   Begin VB.Label lblSections 
      Caption         =   "CFR Sections - Double-click for XML Section Text"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   5280
      TabIndex        =   10
      Top             =   2280
      Width           =   3975
   End
   Begin VB.Label lblParts 
      Caption         =   "CFR Parts for Selected Chapter - Double-click for Sections ->"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   2280
      Width           =   4455
   End
   Begin VB.Label lblChapters 
      Caption         =   "CFR Chapters and Subchapters - Double-click for Parts ->"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   4200
      TabIndex        =   8
      Top             =   120
      Width           =   4935
   End
   Begin VB.Label lblTitles 
      Caption         =   "CFR Titles and Subtitles - Double-click for Chapters ->"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   3975
   End
End
Attribute VB_Name = "frmCFRClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Copyright (c) 2001, 2001, Roger Jennings and OakLeaf Systems
'All World-Wide Rights Reserved
'See the License.txt file in this project's folder for terms
'and conditions of use of this and other related code.

Private rstCFRText As New ADODB.Recordset
Private rstTitles As New ADODB.Recordset
Private rstTitlesXML As New ADODB.Recordset
Private rstSubtitles As New ADODB.Recordset
Private rstChapters As New ADODB.Recordset
Private rstSubchapters As New ADODB.Recordset
Private rstGroupsAndParts As New ADODB.Recordset
Private rstParts As New ADODB.Recordset
Private rstSections As New ADODB.Recordset
Private rstTest As New ADODB.Recordset

Private domDoc As New MSXML2.DOMDocument30
Private clsGetSect As New CFRGetSection   'Class modules
Private clsUpdates As New CFRUpdates

Private blnIsSubtitle As Boolean
Private blnIsChapter As Boolean
Private blnIsSubchapter As Boolean
Private blnIsGroupOrParts As Boolean
Private blnIsParts As Boolean
Private blnPartsLoading As Boolean
Private blnListLoading As Boolean
Private blnMakeTOC As Boolean
Private blnAddTOC As Boolean
Private blnAttribs As Boolean
Private blnAddParts As Boolean
Private blnOneChap As Boolean
Private blnAddSects As Boolean
Private blnGetAllDocs As Boolean
Private blnGetAllSects As Boolean
Private blnNoSectionTest As Boolean
Private blnHalt As Boolean
Private blnOpenInNotepad As Boolean
Private blnUpdating As Boolean

Private astrXML(50) As String
Private strFilter As String
Private str3 As String
Private str6 As String
Private str9 As String
Private str12 As String
Private str15 As String
Private str18 As String
Private str21 As String
Private str24 As String
Private str27 As String
Private strXML As String
Private strPartsLabel As String
Private strRevDate As String
Private strMsg As String

'Descriptions
Private strTitle As String
Private strSubtitle As String
Private strChapter As String
Private strSubchapter As String

Private intTimeout As Integer
Private intXML As Integer

Private sngTime As Single
Private dblShell As Double

Private Sub cmdClientForm_Click()
   'Open the client emulator dialog
   
   frmClientEmulator.Show vbModal
End Sub

Private Sub Form_Load()
   'Initialize some form-level variables
   blnNoSectionTest = False
   intXML = 1
   
   'Indent strings
   str3 = Space$(3)
   str6 = Space$(6)
   str9 = Space$(9)
   str12 = Space$(12)
   str15 = Space$(15)
   str18 = Space$(18)
   str21 = Space$(21)
   str24 = Space$(24)
   str27 = Space$(27)
  
   strRevDate = "January 1, 2001"  'Temporary default
   
   cmdChapTOC.Caption = "Create XML TOC" & vbCrLf & " (Chapter Level)"
   cmdPartTOC.Caption = "Create XML TOC" & vbCrLf & "    (Part Level)"
   strPartsLabel = "XML TOC or Section Document - Double-click to Open in IE 5.5+"
   Call ButtonState(False)
   cmdConnect.Enabled = True
End Sub

Private Sub cmdConnect_Click()
   'Create the connection to the CFRSQL database (default is local)
   Dim rstTest As New ADODB.Recordset
   Dim strSQL As String
   
   'Open or close Connection and Recordsets
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   Me.MousePointer = vbHourglass
   If cmdConnect.Caption = "Connect" Then
      'Open the Connection
      gstrConnect = "Provider=SQLOLEDB;Integrated Security=SSPI;Data Source=(LOCAL);Initial Catalog=CFRSQL"
      'Set the default timeout
      gcnnCFR.CommandTimeout = 300
      gcnnCFR.Open gstrConnect
      'Define a Command object
      Set gcmmCFR.ActiveConnection = gcnnCFR
      'Create required Recordsets (CursorType as Integer)
            
      'Determine indexing status
      strSQL = "SELECT fulltextserviceproperty('IsFulltextInstalled')"
      With rstTest
         If .State = adStateOpen Then
            .Close
         End If
      End With
      Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
      If IsNull(rstTest.Fields(0).Value) Then
         'Error
         gblnFTInstalled = False
      Else
         If CBool(rstTest.Fields(0).Value) Then
            gblnFTInstalled = True
         Else
            gblnFTInstalled = False
         End If
      End If
      rstTest.Close
      Set rstTest = Nothing
      
      'The Titles and Subtitles recordsets stay open (They're very small)
      With rstTitles
         Set .ActiveConnection = gcnnCFR
         .Source = "SELECT * FROM Titles"
         .CursorLocation = adUseServer
         .CursorType = adOpenStatic
         .LockType = adLockReadOnly
         .Open
      End With
      
      With rstSubtitles
         Set .ActiveConnection = gcnnCFR
         .Source = "SELECT * FROM Subtitles"
         .CursorLocation = adUseServer
         .CursorType = adOpenStatic
         .LockType = adLockReadOnly
         .Open
      End With
      
      blnAttribs = True
      Call FillTitlesList
      cmdConnect.Caption = "Disconnect"
      Call ButtonState(True)
      If chkAttribs.Value = 0 Then
         blnAttribs = False
      End If
      
      If Weekday(Date) > 1 And Weekday(Date) < 7 Then
         'Check updated parts Monday through Friday
         Call GetPartsAffectedUI
      End If
   Else
      Call CloseAllADO(True)
      cmdConnect.Caption = "Connect"
      Call ButtonState(False)
      cmdConnect.Enabled = True
   End If
   Me.MousePointer = vbDefault
End Sub

Private Sub FillTitlesList()
   'Fill the titles list and display the titles TOC
   Dim strItem As String
   Dim strTitleID As String
   Dim strTitlAttr As String
   Dim strSubtitleId As String
   Dim strSubtAttr As String
   Dim strSQL As String
   
   Dim blnHasSubs As Boolean
   
   astrXML(intXML) = gstrXMLPrefix & gstrCFRToc & str3 & "<Titles>" & vbCrLf
   With rstTitles
      If .EOF Then
         Exit Sub
      End If
      .MoveFirst
      Do While Not .EOF
         blnHasSubs = False
         strItem = CStr(.Fields(0).Value) & " - " & ToILC(CStr(.Fields(1).Value))
         lstTitles.AddItem strItem
         strTitleID = CStr(.Fields(0).Value)
         strTitlAttr = "TitleID='" & strTitleID & "' "
         If blnAttribs Then
            'Include the TitleID as an attribute
            astrXML(intXML) = astrXML(intXML) & str6 & "<Title id='ti" & strTitleID & "st_' " & strTitlAttr & _
               " >" & vbCrLf & str9 & UCase$(strItem) & vbCrLf
         Else
            astrXML(intXML) = astrXML(intXML) & str6 & "<Title>" & vbCrLf & _
               str9 & strItem & vbCrLf
         End If
         lstTitles.ItemData(lstTitles.ListCount - 1) = CStr(.Fields(0).Value)
         With rstSubtitles
            .MoveFirst
            Do
               .Find "TitleID = " & CStr(rstTitles.Fields(0).Value)
               If .EOF Then
                  If blnHasSubs Then
                     astrXML(intXML) = astrXML(intXML) & str9 & "</Subtitles>" & vbCrLf
                  End If
                  astrXML(intXML) = astrXML(intXML) & str6 & "</Title>" & vbCrLf
                  Exit Do
               Else
                  If Not blnHasSubs Then
                     astrXML(intXML) = astrXML(intXML) & str9 & "<Subtitles>" & vbCrLf
                  End If
                  blnHasSubs = True
                  strItem = str3 & CStr(.Fields(1).Value) & " - " & CStr(.Fields(2).Value)
                  lstTitles.AddItem strItem
                  lstTitles.ItemData(lstTitles.ListCount - 1) = CStr(rstTitles.Fields(0).Value)
                  
                  'Include the TitleID and SubtitleID as an attribute
                  strSubtitleId = CStr(.Fields(1).Value)
                  strSubtAttr = strTitlAttr & "SubtitleID='" & strSubtitleId & "' "
                  If blnAttribs Then
                     astrXML(intXML) = astrXML(intXML) & str12 & "<Subtitle " & "id='ti" & strTitleID & _
                        "st" & strSubtitleId & "' " & strSubtAttr & ">" & vbCrLf
                  Else
                     astrXML(intXML) = astrXML(intXML) & str12 & "<Subtitle>" & vbCrLf
                  End If
                  astrXML(intXML) = astrXML(intXML) & str15 & Trim$(strItem) & vbCrLf & str12 & "</Subtitle>" & vbCrLf
                  .MoveNext
               End If
            Loop
         End With
         .MoveNext
      Loop
      .MoveFirst
   End With
   lstTitles.ListIndex = 0
      
   astrXML(intXML) = astrXML(intXML) & str3 & "</Titles>" & vbCrLf & "</CFRToc>"
   txtDoc.Text = astrXML(intXML)
   'Check TOC for parse errors
   domDoc.loadXML astrXML(intXML)
   If domDoc.parseError.errorCode <> 0 Then
      Stop
   End If

   'Save XML in a text file
   gstrFile = App.Path & "\TitlesTOC.xml"
   If Len(Dir(gstrFile)) > 0 Then
      Kill gstrFile
   End If
   Open gstrFile For Binary As #1
   Put #1, , astrXML(intXML)
   Close #1
   
   'Update the only record in the TitlesTOC table
   strSQL = "UPDATE TitlesTOC SET HasTOC = 1, TOCText = '" & Replace$(astrXML(intXML), "'", "''") & _
      "', TOCLength = " & CStr(Len(astrXML(intXML)))
   With gcmmCFR
      .CommandType = adCmdText
      .CommandText = strSQL
      .Execute
   End With
   astrXML(intXML) = ""
End Sub

Private Sub GetPartsAffectedUI()
   'Get the parts updated records
   Dim strPartsUpdated As String
   Dim strMsg As String
   Dim clsUpdates As New CFRUpdates
   
   If chkUpdates.Value = 0 Then
      Exit Sub
   End If
   
   Call ButtonState(False)
   Me.MousePointer = vbHourglass
   DoEvents
   DoEvents
   'Get the
   strPartsUpdated = clsUpdates.GetPartsAffected(gstrConnect, "")
   If Val(strPartsUpdated) > 0 Then
      strMsg = CStr(strPartsUpdated) & " part(s) were updated on " & Format$(Date, "mmmm dd, yyyy") & "." & vbCrLf & vbCrLf & _
         "Click the Get Updates button to process today's updates or updates you missed."
      MsgBox strMsg, vbOKOnly + vbInformation, "Daily CFR Parts Update from the Federal Register"
   Else
      If Len(strPartsUpdated) > 4 Then
         'It's an error message
         MsgBox strPartsUpdated, vbOKOnly + vbInformation, "Error Getting CFR Parts Update"
      End If
   End If
   
   Call ButtonState(True)
   Me.MousePointer = vbDefault
   Set clsUpdates = Nothing
End Sub

Private Sub OpenInIE(ByVal strURL As String)
   'Does what it says
   dblShell = Shell("\Program Files\Internet Explorer\Iexplore.exe " & strURL, vbMaximizedFocus)
End Sub

Private Sub cmdUpdates_Click()
   'Process updates from this or last month's Parts Affected pages
   Dim strMsg As String
   Dim strList As String
   Dim strMonth As String
   Dim strPartsUpdated As String
  
   Dim intChoice As Integer

   Call ProcessUpdates
   
   strMsg = "This process adds missing records to the PartsAffected table for this " & _
      "or the previous month. The purpose of the process is to assure that all section " & _
      "text in the database is current, even if you miss a daily update. (Daily updates " & _
      "occur automatically unless you clear the Updates check box.)" & vbCrLf & vbCrLf
   strMsg = strMsg & "After the process obtains the list of updated parts, a message asks " & _
      "if you want' to process the updates for the parts and sections tables now." & vbCrLf & vbCrLf
   strMsg = strMsg & "Click Yes to process the current month's updates, click No to " & _
      "process last month's updates, or click Cancel to exit."
   intChoice = MsgBox(strMsg, vbYesNoCancel + vbQuestion, "Process This or Last Month's Updated Parts")
   
   If intChoice = vbYes Then
      strList = "CurrMonth"
      strMonth = "This Month's "
   ElseIf intChoice = vbNo Then
      strList = "LastMonth"
      strMonth = "Last Month's "
   End If
   
   'Update the database
   Me.MousePointer = vbHourglass
   DoEvents
   Call ButtonState(False)
   strPartsUpdated = clsUpdates.GetPartsAffected(gstrConnect, strList)
   Set clsUpdates = Nothing
   Me.MousePointer = vbDefault
   If Val(strPartsUpdated) > 0 Then
      strMsg = CStr(strPartsUpdated) & " part(s) were added to the PartsAffected table."
      MsgBox strMsg, vbOKOnly + vbInformation, strMonth & "CFR Parts Update from the Federal Register"
   Else
      If Len(strPartsUpdated) > 4 Then
         'It's an error message
         MsgBox strPartsUpdated, vbOKOnly + vbInformation, "Error Getting CFR Parts Update"
      Else
         strMsg = "No parts were updated by this operation." & vbCrLf & _
            "If you have unprocessed updates, you have the option of processing them now."
         MsgBox strMsg, vbOKOnly + vbInformation, "Update Test Completed"
      End If
   End If
   Call ButtonState(True)
   Call ProcessUpdates
End Sub

Private Sub ProcessUpdates()
   'Process all unprocessed updates
   
   Dim rstUpdates As New ADODB.Recordset
   
   Dim strMsg As String
   Dim strSQL As String
   Dim strPartsUpdated As String
   
   strSQL = "SELECT COUNT(*) FROM PartsAffected WHERE DateProcessed IS NULL"
   With rstUpdates
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstUpdates = gcnnCFR.Execute(strSQL, , adCmdText)
   If CStr(rstUpdates.Fields(0).Value) > 0 Then
      strMsg = "You have " & Format$(CStr(rstUpdates.Fields(0).Value), "#,##0") & " CFR part updates that haven't been processed. " & _
         "Do you want to update the parts and sections now?"
      If MsgBox(strMsg, vbYesNo + vbQuestion, "Process Updated Parts Now?") = vbYes Then
         Call ButtonState(False)
         cmdHalt.Enabled = True
         blnUpdating = True
         Me.MousePointer = vbHourglass
         txtDoc.Text = "Processing parts updates. Click Halt to stop processing."
         DoEvents
         
         strPartsUpdated = clsUpdates.ProcessPartsAffected(gstrConnect)
         Set clsUpdates = Nothing
         
         blnUpdating = False
         Call ButtonState(True)
         cmdHalt.Enabled = False
         Me.MousePointer = vbDefault
         MsgBox strPartsUpdated, vbOKOnly + vbInformation, "Processing Parts Updates Completed"
      End If
   End If
   
   With rstUpdates
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstUpdates = Nothing
End Sub

Private Sub OpenFile(ByVal strHTML As String, ByVal strFile As String)
   'Temporary for testing
   'Save HTML in a file
   gstrFile = App.Path & "\" & strFile
   If Len(Dir(gstrFile)) > 0 Then
      Kill gstrFile
   End If
   Open gstrFile For Binary As #1
   Put #1, , strHTML
   Close #1
   dblShell = Shell("Notepad.exe " & gstrFile, vbNormalFocus)
End Sub


'********************************************
'Handlers for Creating XML Tables of Contents
'********************************************

Public Sub cmdChapTOC_Click()
   'Create the TOC for all Titles to the chapter level
   'Takes about a minute on a fast machine
   Dim intCtr As Integer
      
   intXML = 1
   blnMakeTOC = True
   Me.MousePointer = vbHourglass
   cmdHalt.Enabled = True
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   
   astrXML(intXML) = gstrXMLPrefix & gstrCFRToc & str3 & "<Titles>" & vbCrLf
   With lstTitles
      For intCtr = 0 To .ListCount - 1
         .ListIndex = intCtr
         DoEvents
         Call lstTitles_DblClick
         
         If .ListIndex < .ListCount - 1 Then
            If Left$(.List(.ListIndex), 1) = " " And Left$(.List(.ListIndex + 1), 1) <> " " Then
               'Next item is a title, so close the subtitles
               astrXML(intXML) = astrXML(intXML) & str9 & "</Subtitles>" & vbCrLf
            End If
         Else
            'Last title is a subtitle (can't short-circuit)
            If Left$(.List(.ListIndex), 1) = " " Then
               astrXML(intXML) = astrXML(intXML) & str9 & "</Subtitles>" & vbCrLf
            End If
         End If
         If Left$(.List(.ListIndex), 1) <> " " Then
            astrXML(intXML) = astrXML(intXML) & str6 & "</Title>" & vbCrLf
            If blnHalt Then
               'Escape hatch
               blnHalt = False
               Exit For
            End If
         End If
      Next intCtr
   End With
   
   Me.MousePointer = vbHourglass
   astrXML(intXML) = astrXML(intXML) & str3 & "</Titles>" & vbCrLf & "</CFRToc>"
   'Only load the first 10,000 chars in the text box
   txtDoc.Text = Left$(astrXML(1), 10000)
   strXML = ""
   
   For intCtr = 1 To intXML
      strXML = strXML & astrXML(intCtr)
      astrXML(intCtr) = ""
   Next intCtr
   'Save XML in a text file
   If blnAddParts Then
      If blnAddSects Then
         '20 MB without
         gstrFile = App.Path & "\SectionsTOC.xml"
      Else
         '292 KB with attributes, 209 KB without
         gstrFile = App.Path & "\PartsTOC.xml"
      End If
   Else
      gstrFile = App.Path & "\ChaptersTOC.xml"
   End If
   If Len(Dir(gstrFile)) > 0 Then
      Kill gstrFile
   End If
   Open gstrFile For Binary As #1
   Put #1, , strXML
   Close #1
   strXML = ""
   Me.MousePointer = vbDefault
   blnMakeTOC = False
   cmdHalt.Enabled = False
End Sub

Private Sub cmdPartTOC_Click()
   'Add parts to the TOC (LARGE file, LONG time)
   Dim strMsg As String
   
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = True
   
   If blnAddSects Then
      blnOpenInNotepad = True
      strMsg = "You have marked the 'Add Section Elements' check box, " & _
         "which adds more than 100,000 lines to the XML table of contents. " & _
         "Creating this TOC can take more than an hour and creates a 20 MB XML file. " & _
         "Attempting to open this file in IE 5.5+ with less than 1 GB of RAM " & _
         "consumes ALL virtual memory, so double-clicking the text box " & _
         "opens the file in Notepad. (You can stop TOC generation and create " & _
         "a well-formed XML document by clicking Halt at any time.)" & vbCrLf & vbCrLf & _
         "Are you SURE you want to create this giant TOC? If so, click OK."
      If MsgBox(strMsg, vbOKCancel + vbExclamation, "TOC Is Too Large for IE 5.5+") <> vbOK Then
         chkAddSects.Value = 0
         blnOpenInNotepad = False
         lblDoc.Caption = strPartsLabel
         Exit Sub
      End If
   End If
   blnAddParts = True
   Call cmdChapTOC_Click
   If chkAddParts.Value = 0 Then
      blnAddParts = False
   End If
   lblDoc.Caption = "XML TOC with Parts and Sections - Double-click to Open in Notepad"
End Sub

Private Sub chkAttribs_Click()
   'Mark to add search attributes to element tags
   If chkAttribs.Value = 1 Then
      blnAttribs = True
   Else
      blnAttribs = False
   End If
End Sub

Private Sub lstTitles_DblClick()
   'Fill the chapters/subchapters list
   Dim strItem As String
   Dim strTitleID As String
   Dim strSubtitleId As String
   
   Me.MousePointer = vbHourglass
   lstChapters.Clear
   lstParts.Clear
   lstSections.Clear
   txtDoc.Text = ""
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   DoEvents
     
   With lstTitles
      strItem = .List(.ListIndex)
      lstTitles.ToolTipText = strItem
      strTitleID = CStr(.ItemData(.ListIndex))
      'Type conversion is REQUIRED here (reason unknown)
      intXML = CInt(.ItemData(.ListIndex))
      If InStr(strItem, "[Reserved]") > 0 And Not blnMakeTOC Then
         lstChapters.AddItem "No chapters in reserved title"
         If Not blnAddTOC Then
            Me.MousePointer = vbDefault
         End If
         Exit Sub
      End If
      Call ButtonState(False)
      strFilter = "TitleID = " & strTitleID
      If Left(strItem, 1) = " " Then
         'Its a subtitle
         strSubtitleId = Trim$(Left$(strItem, InStr(strItem, " - ")))
         strSubtitle = strItem
         With rstTitles
            .MoveFirst
            .Find "TitleID = '" & strTitleID & "'"
            If .EOF Then
               'Big problem
            Else
               strTitle = CStr(.Fields(0).Value) & " - " & UCase$(CStr(.Fields(1).Value))
            End If
         End With
      Else
         'strTitle = "TITLE " & UCase$(strItem)
         strTitle = UCase$(strItem)
         strSubtitleId = "-"
         strSubtitle = ""
      End If
   End With
   Call FillChaptersList(strTitleID, strTitle, strSubtitleId, strSubtitle, True)
   If Not blnAddTOC Then
      Call ButtonState(True)
      Me.MousePointer = vbDefault
   End If
End Sub

Private Sub chkAddParts_Click()
   If chkAddParts.Value = 1 Then
      blnAddParts = True
      chkAddSects.Visible = True
   Else
      blnAddParts = False
      chkAddSects.Visible = False
   End If
   'Call FillTitlesList
End Sub

Private Sub cmdHalt_Click()
   'Flag to stop bulk operations
   If blnUpdating Then
      'Send a halt message
      Call clsUpdates.HaltPartsProcessing
   Else
      blnHalt = True
   End If
   Me.MousePointer = vbDefault
End Sub

Private Sub FillChaptersList(strTitleID As String, strTitle As String, strSubtitleId As String, strSubtitle As String, blnList As Boolean)
   'Add the chapters/subchapters for the title/subtitle
   Dim strChapterId As String
   Dim strChapAttr As String
   Dim strSubChapID As String
   Dim strItem As String
   Dim strFiltTitle As String
   Dim strTemp As String
   Dim strSQL As String
   Dim strXML As String
   Dim strID As String
   
   Dim intUpdated As Integer
  
   Dim blnSubtitle As Boolean
   Dim blnPartsOnly As Boolean
   Dim blnSpecCase As Boolean
         
   strID = "id='ti" & strTitleID
   blnSpecCase = False
   If Not blnMakeTOC Then
      astrXML(intXML) = gstrXMLPrefix & gstrCFRToc & str3 & "<Titles>" & vbCrLf
   End If
   If strSubtitleId = "-" Or Not blnMakeTOC Then
      'Add the Title tag
      If strSubtitleId = "-" Then
         strID = strID & "st_"
      Else
         strID = strID & "st" & strSubtitleId
      End If
      If blnAttribs Then
         astrXML(intXML) = astrXML(intXML) & str6 & "<Title " & strID & "' TitleID='" & strTitleID & "' >" & vbCrLf & str9 & strTitle & vbCrLf
      Else
         astrXML(intXML) = astrXML(intXML) & str6 & "<Title>" & vbCrLf & str9 & strTitle & vbCrLf
      End If
   End If
   
   If strSubtitleId <> "-" Then
      'Duplicate line below is intentional
      If (blnMakeTOC And strSubtitleId = "A") Or Not blnMakeTOC Then
         astrXML(intXML) = astrXML(intXML) & str9 & "<Subtitles>" & vbCrLf
      ElseIf blnMakeTOC And strTitleID = "41" And strSubtitleId = "B" Then
         'Special-case the one title having subtitles starting with B
         astrXML(intXML) = astrXML(intXML) & str9 & "<Subtitles>" & vbCrLf
      End If
      If blnAttribs Then
         astrXML(intXML) = astrXML(intXML) & str12 & "<Subtitle " & strID & "' TitleID='" & strTitleID & _
            "' SubtitleID='" & strSubtitleId & "' >" & vbCrLf
      Else
         astrXML(intXML) = astrXML(intXML) & str12 & "<Subtitle>" & vbCrLf
      End If
      astrXML(intXML) = astrXML(intXML) & str15 & Trim$(strSubtitle) & vbCrLf
      blnSubtitle = True
   End If
   
   strChapAttr = "TitleID='" & strTitleID & "' SubtitleID='" & strSubtitleId & "' "
   strFiltTitle = "TitleID = " & strTitleID & " AND SubtitleID = '" & strSubtitleId & "'"
   
   With rstChapters
      If .State = adStateOpen Then
         .Close
      End If
      strSQL = "SELECT * FROM Chapters WHERE " & strFiltTitle
      Set rstChapters = gcnnCFR.Execute(strSQL, , adCmdText)
   End With
   
   With rstChapters
      If .EOF Then
         'The title or subtitle doesn't have chapters, only parts
         If blnSubtitle Then
            lstChapters.AddItem "This subtitle has no chapters"
         Else
            lstChapters.AddItem "This title has no chapters"
         End If
         blnPartsOnly = True
         If blnSubtitle And (strTitleID = "45" And InStr(astrXML(intXML), "<Parts>") = 0) Then
            'Special case for Title 45, which is missing Chapter I
            strFilter = "TitleID = 45 AND SubtitleID = 'A' AND ChapterID = 0 AND SubchapterID = 'A'"
            blnSpecCase = True
            'Literal subchapter name is OK because it's a special case
            astrXML(intXML) = astrXML(intXML) & str15 & "<Subchapters>" & vbCrLf & _
               str18 & "<Subchapter>" & vbCrLf & str21 & _
               "A - Department of Health and Human Services, General Administration" & vbCrLf
         Else
            strFilter = strFiltTitle & " AND ChapterID = 0 AND SubchapterID = '-'"
         End If
         Call FillPartsList(strFilter, blnPartsOnly, blnSpecCase)
      Else
         blnPartsOnly = False
         If blnSubtitle Then
            astrXML(intXML) = astrXML(intXML) & str15
         Else
            astrXML(intXML) = astrXML(intXML) & str9
         End If
         astrXML(intXML) = astrXML(intXML) & "<Chapters>" & vbCrLf

         'Process the title/subtititle's chapters
         Do While Not .EOF
            strChapterId = CStr(.Fields(2).Value)
            strItem = CStr(.Fields(3).Value) & " - " & CStr(.Fields(4).Value)
            lstChapters.AddItem strItem
            lstChapters.ItemData(lstChapters.ListCount - 1) = CInt(strChapterId)
            If blnMakeTOC Or blnAddParts Then
               lstChapters.ListIndex = lstChapters.ListCount - 1
            End If
            DoEvents
            strChapAttr = "TitleID='" & strTitleID & "' SubtitleID='" & strSubtitleId & _
               "' ChapterID='" & strChapterId & "' "
            If blnSubtitle Then
               astrXML(intXML) = astrXML(intXML) & str18
            Else
               astrXML(intXML) = astrXML(intXML) & str12
            End If
            If blnAttribs Then
               astrXML(intXML) = astrXML(intXML) & "<Chapter " & strID & "ch" & strChapterId & "sc_' " & strChapAttr & " >" & vbCrLf
            Else
               astrXML(intXML) = astrXML(intXML) & "<Chapter>" & vbCrLf
            End If
            If blnSubtitle Then
               astrXML(intXML) = astrXML(intXML) & str21
            Else
               astrXML(intXML) = astrXML(intXML) & str15
            End If
            astrXML(intXML) = astrXML(intXML) & strItem & vbCrLf
            strFilter = strFiltTitle & " AND ChapterID = " & strChapterId
            If blnAddParts Then
               strTemp = strFilter & " AND SubchapterID = '-'"
               Call FillPartsList(strTemp, blnPartsOnly, False)
            End If
            'Process subchapters, if present
            With rstSubchapters
               If .State = adStateOpen Then
                  .Close
               End If
               strSQL = "SELECT * FROM Subchapters WHERE " & strFilter
               Set rstSubchapters = gcnnCFR.Execute(strSQL, , adCmdText)
            End With
            With rstSubchapters
               If .EOF Then
                  'No subchapters
                  If blnSubtitle Then
                     astrXML(intXML) = astrXML(intXML) & str18
                  Else
                     astrXML(intXML) = astrXML(intXML) & str12
                  End If
                  astrXML(intXML) = astrXML(intXML) & "</Chapter>" & vbCrLf
               Else
                  If blnSubtitle Then
                     astrXML(intXML) = astrXML(intXML) & str21
                  Else
                     astrXML(intXML) = astrXML(intXML) & str15
                  End If
                  astrXML(intXML) = astrXML(intXML) & "<Subchapters>" & vbCrLf
                  Do While Not .EOF
                     If blnList Then
                        'Create the chapters list
                        strSubChapID = CStr(.Fields(3).Value)
                        strItem = strSubChapID & " - " & ToILC(CStr(.Fields(4).Value))
                        lstChapters.AddItem "   " & strItem
                        lstChapters.ItemData(lstChapters.ListCount - 1) = CStr(rstChapters.Fields(2).Value)
                        DoEvents
                        If blnSubtitle Then
                           astrXML(intXML) = astrXML(intXML) & str24
                        Else
                           astrXML(intXML) = astrXML(intXML) & str18
                        End If
                        If blnAttribs Then
                           astrXML(intXML) = astrXML(intXML) & "<Subchapter " & strID & "ch" & strChapterId & _
                              "sc" & strSubChapID & "' " & strChapAttr & " SubchapterID='" & strSubChapID & "' >" & vbCrLf
                        Else
                           astrXML(intXML) = astrXML(intXML) & "<Subchapter>" & vbCrLf
                        End If
                        If blnSubtitle Then
                           astrXML(intXML) = astrXML(intXML) & str27 & UCase$(strItem) & vbCrLf & str24
                        Else
                           astrXML(intXML) = astrXML(intXML) & str21 & UCase$(strItem) & vbCrLf & str18
                        End If
                        If blnAddParts Then
                           'Add parts to the chapter
                           strTemp = strFilter & " AND SubchapterID = '" & strSubChapID & "'"
                           Call FillPartsList(strTemp, blnPartsOnly, False)
                           If blnSubtitle Then
                              astrXML(intXML) = astrXML(intXML) & str24
                           Else
                              astrXML(intXML) = astrXML(intXML) & str18
                           End If
                        End If
                        astrXML(intXML) = astrXML(intXML) & "</Subchapter>" & vbCrLf
                     End If
                     .MoveNext
                  Loop
                  If blnSubtitle Then
                     astrXML(intXML) = astrXML(intXML) & str21
                  Else
                     astrXML(intXML) = astrXML(intXML) & str15
                  End If
                  astrXML(intXML) = astrXML(intXML) & "</Subchapters>" & vbCrLf
                  If blnSubtitle Then
                     astrXML(intXML) = astrXML(intXML) & str18
                  Else
                     astrXML(intXML) = astrXML(intXML) & str12
                  End If
                  astrXML(intXML) = astrXML(intXML) & "</Chapter>" & vbCrLf
               End If
            End With
            .MoveNext
         Loop
      End If
      
      If blnPartsOnly Then
         'It's not a chapter
         If blnSpecCase Then
               astrXML(intXML) = astrXML(intXML) & str18 & "</Subchapter>" & vbCrLf & _
                  str15 & "</Subchapters>" & vbCrLf
         End If
         If blnSubtitle Then
            astrXML(intXML) = astrXML(intXML) & str12 & "</Subtitle>" & vbCrLf
            If Not blnMakeTOC Then
               astrXML(intXML) = astrXML(intXML) & str9 & "</Subtitles>" & vbCrLf
            End If
         End If
      Else
         If blnSubtitle Then
            astrXML(intXML) = astrXML(intXML) & str15 & "</Chapters>" & vbCrLf & str12 & "</Subtitle>" & vbCrLf
            If Not blnMakeTOC Then
               astrXML(intXML) = astrXML(intXML) & str9 & "</Subtitles>" & vbCrLf
            End If
         Else
            astrXML(intXML) = astrXML(intXML) & str9 & "</Chapters>" & vbCrLf
         End If
      End If
      If Not blnMakeTOC Then
         astrXML(intXML) = astrXML(intXML) & str6 & "</Title>" & vbCrLf & str3 & "</Titles>" & vbCrLf & "</CFRToc>"
      End If
      .Close
   End With
   If InStr(astrXML(intXML), "</Title>" & vbCrLf & "      </Title>") > 0 Then
      'This is a temporary hack
      astrXML(intXML) = Replace$(astrXML(intXML), "</Title>" & vbCrLf & "      </Title>", "</Title>" & vbCrLf)
   End If
   If Not blnMakeTOC Then
      If InStr(astrXML(intXML), "<Chapters>") > 0 Or InStr(astrXML(intXML), "<Parts>") > 0 Then
      'If InStr(UCase$(astrXML(intXML)), "RESERVED") = 0 Then
         'Don't display or save files for reserved titles
         'Check TOC for parse errors
         domDoc.loadXML astrXML(intXML)
         If domDoc.parseError.errorCode <> 0 Then
            Stop
         End If
         txtDoc.Text = astrXML(intXML)
         'Save XML in a text file
         gstrFile = App.Path & "\Chapters.xml"
         If Len(Dir(gstrFile)) > 0 Then
            Kill gstrFile
         End If
         Open gstrFile For Binary As #1
         Put #1, , astrXML(intXML)
         Close #1
         
         'Update the title or subtitle TOC
         If blnSubtitle Then
            strSQL = "UPDATE Subtitles SET HasTOC = 1, "
         Else
            strSQL = "UPDATE Titles SET HasTOC = 1, "
         End If
         If Len(astrXML(intXML)) < 7000 Then
            strSQL = strSQL & "TOCText = NULL, TOCChar = '" & Replace$(astrXML(intXML), "'", "''") & "', "
         Else
            strSQL = strSQL & "TOCChar = NULL, TOCText = '" & Replace$(astrXML(intXML), "'", "''") & "', "
         End If
         strSQL = strSQL & "TOCLength = " & CStr(Len(astrXML(intXML))) & " WHERE TitleID = " & strTitleID
         If blnSubtitle Then
            strSQL = strSQL & " AND SubTitleID = '" & strSubtitleId & "'"
          End If
      Else
         If blnSubtitle Then
            strSQL = "UPDATE Subtitles SET HasTOC = 0 WHERE TitleID = " & _
               strTitleID & " AND SubTitleID = '" & strSubtitleId & "'"
         Else
            strSQL = "UPDATE Titles SET HasTOC = 0 WHERE TitleID = " & strTitleID
         End If
         txtDoc.Text = ""
      End If
      If blnAddTOC Then
         'Update the Titles or Subtitles table
         With gcmmCFR
            .CommandType = adCmdText
            .CommandText = strSQL
            .Execute intUpdated
         End With
         If intUpdated <> 1 Then
            Stop
         End If
      End If
      astrXML(intXML) = ""
   End If
End Sub

Private Sub lstChapters_DblClick()
   'Fill the parts list for the chapter
   Dim strItem As String
   Dim strPartFilter As String
   
   Me.MousePointer = vbHourglass
   lstParts.Clear
   lstSections.Clear
   txtDoc.Text = ""
   Call ButtonState(False)
   blnAddParts = True
   blnOneChap = True
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   
   strPartFilter = Left$(strFilter, InStr(strFilter, "AND ChapterID") - 1)
   
   With lstChapters
      strItem = .List(.ListIndex)
      lstChapters.ToolTipText = strItem
      If Left$(strItem, 1) = " " Then
         'It's a subchapter
         strPartFilter = strPartFilter & " AND ChapterID = " & _
            CStr(.ItemData(.ListIndex)) & " AND SubchapterID = '" & _
            Trim$(Left$(strItem, InStr(strItem, " - "))) & "'"
      Else
         'It's a chapter
         strPartFilter = strPartFilter & " AND ChapterID = " & _
            CStr(.ItemData(.ListIndex)) & " AND SubchapterID = '-'"
      End If
   End With
   Call FillPartsList(strPartFilter, False, False)
   If chkAddParts.Value = 0 Then
      blnAddParts = False
   End If
   blnOneChap = False
   If Not blnAddTOC Then
      Call ButtonState(True)
      Me.MousePointer = vbDefault
   End If
End Sub

Private Sub chkAddSects_Click()
   If chkAddSects.Value = 1 Then
      blnAddSects = True
   Else
      blnAddSects = False
   End If
End Sub

Private Sub FillPartsList(strFilt As String, blnFromTitles As Boolean, blnSpecCase As Boolean)
   'Fill the parts list based on the specified filter
   'or SQL statement
   Dim strTitleID As String
   Dim strTitle As String
   Dim strSubtitleId As String
   Dim strSubtitle As String
   Dim strChapterId As String
   Dim strChapter As String
   Dim strSubchapterId As String
   Dim strSubchapter As String
   Dim strPartID As String
   Dim strSectID As String
   Dim strItem As String
   Dim strSQL As String
   Dim strChapXML As String
   Dim strTemp As String
   Dim strID As String
   
   Dim intSp As Integer
   Dim intCtr As Integer
   
   Dim blnSubtitle As Boolean
   Dim blnSubchapter As Boolean
   
   lstParts.Clear
   DoEvents
   With rstParts
      If .State = adStateOpen Then
         .Close
      End If
      strSQL = "SELECT * FROM Parts WHERE " & strFilt
      Set rstParts = gcnnCFR.Execute(strSQL, , adCmdText)
   End With
   'Split is required here
   With rstParts
      If .EOF Then
         With lstChapters
            If .ListIndex < (.ListCount - 1) And Not (blnFromTitles Or blnMakeTOC) Then
               If Left$(.List(.ListIndex + 1), 1) = " " Then
                  'It's a chapter only with subchapters, so needs a chapter TOC
                  'Create a chapter TOC with only subchapter entries
                  'Add the header for the chapter by working the lists
                  With lstTitles
                     strTitleID = CStr(.ItemData(.ListIndex))
                     strID = "id='ti" & strTitleID
                     strTemp = .List(.ListIndex)
                     strTitle = UCase$(strTemp)
                     If Left$(strTemp, 1) = " " Then
                        'It's a subtitle; get it and the title string
                        blnSubtitle = True
                        strSubtitle = Trim$(strTemp)
                        strSubtitleId = Left$(strSubtitle, InStr(strSubtitle, " ") - 1)
                        strID = strID & "st" & strSubtitleId
                        'strSubtitle = "Subtitle " & Mid$(strTemp, InStr(strTemp, " - ") + 3)
                        intCtr = .ListIndex
                        'Find the title
                        Do While Left$(.List(.ListIndex), 1) = " " And .ListIndex >= 0
                           .ListIndex = .ListIndex - 1
                        Loop
                        strTitle = UCase$(.List(.ListIndex))
                        'strTitle = Mid$(strTitle, InStr(strTitle, " - ") + 3)
                        'Return to original item
                        .ListIndex = intCtr
                     Else
                        blnSubtitle = False
                        strSubtitleId = "-"
                        strID = strID & "st_"
                     End If
                  End With
                  
                  'Get the chapter number and name
                  strChapterId = CStr(.ItemData(.ListIndex))
                  'strChapter = "Chapter " & .List(.ListIndex)
                  strChapter = .List(.ListIndex)
                  strChapXML = gstrXMLPrefix & gstrCFRToc & str3 & "<Titles>" & vbCrLf
                  If blnAttribs Then
                     strChapXML = strChapXML & str6 & "<Title " & strID & "' TitleID='" & strTitleID & "' >" & vbCrLf
                  Else
                     strChapXML = strChapXML & str6 & "<Title>" & vbCrLf
                  End If
                  strChapXML = strChapXML & str9 & strTitle & vbCrLf
                  If blnSubtitle Then
                     strChapXML = strChapXML & str9 & "<Subtitles>" & vbCrLf
                     If blnAttribs Then
                        strChapXML = strChapXML & str12 & "<Subtitle " & strID & "' TitleID='" & strTitleID & _
                           "' SubtitleID='" & strSubtitleId & "' >" & vbCrLf
                     Else
                        strChapXML = strChapXML & str12 & "<Subtitle>" & vbCrLf
                     End If
                     strChapXML = strChapXML & str15 & strSubtitle & vbCrLf
                     intSp = 15
                  Else
                     intSp = 9
                  End If
                  strChapXML = strChapXML & Space$(intSp) & "<Chapters>" & vbCrLf
                  intSp = intSp + 3
                  If blnAttribs Then
                     strID = strID & "ch" & strChapterId
                     strChapXML = strChapXML & Space$(intSp) & "<Chapter " & strID & "sc_' TitleID='" & _
                        strTitleID & "' SubtitleID = '" & strSubtitleId & "' ChapterID = '" & strChapterId & "' >" & vbCrLf
                  Else
                     strChapXML = strChapXML & Space$(intSp) & "<Chapter>" & vbCrLf
                  End If
                  strChapXML = strChapXML & Space$(intSp + 3) & strChapter & vbCrLf
                  intSp = intSp + 3
                  strChapXML = strChapXML & Space$(intSp) & "<Subchapters>" & vbCrLf
                  intSp = intSp + 3
                  intCtr = .ListIndex
                  
                  'Get the subchapters
                  .ListIndex = .ListIndex + 1
                  Do While Left$(.List(.ListIndex), 1) = " "
                     strTemp = Trim$(.List(.ListIndex))
                     strSubchapterId = Left$(strTemp, InStr(strTemp, " ") - 1)
                     If blnAttribs Then
                        strChapXML = strChapXML & Space$(intSp) & "<Subchapter " & strID & "sc" & strSubchapterId & "' TitleID='" & _
                        strTitleID & "' SubtitleID = '" & strSubtitleId & "' ChapterID = '" & _
                           strChapterId & "' SubchapterID = '" & strSubchapterId & "' >" & vbCrLf
                     Else
                        strChapXML = strChapXML & Space$(intSp) & "<Subchapter>" & vbCrLf
                     End If
                     strSubchapter = UCase$(strTemp)
                     strChapXML = strChapXML & Space$(intSp + 3) & strSubchapter & vbCrLf
                     strChapXML = strChapXML & Space$(intSp) & "</Subchapter>" & vbCrLf
                     If .ListIndex = .ListCount - 1 Then
                        'Don't go past the last item
                        Exit Do
                     End If
                     .ListIndex = .ListIndex + 1
                  Loop
                  'Return to orginal location
                  .ListIndex = intCtr
                  If blnSubtitle Then
                     strChapXML = strChapXML & str21 & "</Subchapters>" & vbCrLf
                     strChapXML = strChapXML & str18 & "</Chapter>" & vbCrLf & str15 & "</Chapters>" & vbCrLf
                     strChapXML = strChapXML & str12 & "</Subtitle>" & vbCrLf & str9 & "</Subtitles>" & vbCrLf
                  Else
                     strChapXML = strChapXML & str15 & "</Subchapters>" & vbCrLf
                     strChapXML = strChapXML & str12 & "</Chapter>" & vbCrLf & str9 & "</Chapters>" & vbCrLf
                  End If
                  strChapXML = strChapXML & str6 & "</Title>" & vbCrLf & str3 & "</Titles>" & vbCrLf & "</CFRToc>"
               End If
            End If
         End With
      Else
         strTitleID = CStr(.Fields(0).Value)
         strSubtitleId = CStr(.Fields(1).Value)
         strID = "id='ti" & strTitleID
         strChapterId = CStr(.Fields(2).Value)
         strSubchapterId = CStr(.Fields(3).Value)
         If strSubchapterId = "-" Then
            blnSubchapter = False
         Else
            blnSubchapter = True
         End If
         If blnFromTitles Then
            'Parts are directly under a title or subtitle
            If blnSubtitle Then
               astrXML(intXML) = astrXML(intXML) & str15
               intSp = 18
               strID = strID & "st" & strSubtitleId & "ch0sc_"
            Else
               astrXML(intXML) = astrXML(intXML) & str9
               intSp = 12
               strID = strID & "st_ch0sc_"
            End If
            If blnSpecCase Then
               intSp = intSp + 6
            End If
            astrXML(intXML) = Trim$(astrXML(intXML)) & Space$(intSp - 3) & "<Parts>" & vbCrLf
         Else
            'Parts are under a chapter or subchapter
            If blnSubchapter Then
               intSp = 21
            Else
               intSp = 15
            End If
            If blnSubtitle Then
               intSp = intSp + 6
            End If
   
            If blnAddParts Or blnAddTOC Then
               'Get title, subtitle, etc.
               With rstTest
                  'Get the title
                  If .State = adStateOpen Then
                     .Close
                  End If
                  strSQL = "SELECT Title FROM Titles WHERE TitleID = " & strTitleID
                  Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
               End With
               strTitle = strTitleID & " - " & CStr(rstTest.Fields(0).Value)
               If blnSubtitle Then
                  'Get subtitle
                  rstTest.Close
                  Set rstTest = Nothing
                  strSQL = "SELECT Subtitle FROM Subtitles WHERE TitleID = " & strTitleID & " AND SubtitleID = '" & strSubtitleId & "'"
                  Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
                  strSubtitle = strSubtitleId & " - " & CStr(rstTest.Fields(0).Value)
               Else
                  strSubtitle = ""
               End If
               rstTest.Close
               Set rstTest = Nothing
               'Get chapter
               strSQL = "SELECT ChapterNum, Chapter FROM Chapters WHERE TitleID = " & strTitleID & " AND SubtitleID = '" & strSubtitleId & _
                  "' AND ChapterID = " & strChapterId
               Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
               strChapter = "Chapter " & CStr(rstTest.Fields(0).Value) & " - " & CStr(rstTest.Fields(1).Value)
               rstTest.Close
               Set rstTest = Nothing
               If blnSubchapter Then
                  'Get subchapter
                  strSQL = "SELECT Subchapter FROM Subchapters WHERE TitleID = " & strTitleID & " AND SubtitleID = '" & strSubtitleId & _
                     "' AND ChapterID = " & strChapterId & " AND SubchapterID = '" & strSubchapterId & "'"
                  Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
                  strSubchapter = strSubchapterId & " - " & CStr(rstTest.Fields(0).Value)
                  rstTest.Close
                  Set rstTest = Nothing
               Else
                  strSubchapter = ""
               End If
               
               If blnMakeTOC Or (blnAddParts And Not blnOneChap) Then
                  'Stop
               Else
                  'Add the header for the chapter
                  astrXML(intXML) = gstrXMLPrefix & gstrCFRToc & str3 & "<Titles>" & vbCrLf
                  If blnAttribs Then
                     astrXML(intXML) = astrXML(intXML) & str6 & "<Title " & strID & "st_' TitleID='" & strTitleID & "' >" & vbCrLf
                  Else
                     astrXML(intXML) = astrXML(intXML) & str6 & "<Title>" & vbCrLf
                  End If
                  astrXML(intXML) = astrXML(intXML) & str9 & strTitle & vbCrLf
                  If blnSubtitle Then
                     strID = strID & "st" & strSubtitleId
                     astrXML(intXML) = astrXML(intXML) & str9 & "<Subtitles>" & vbCrLf
                     If blnAttribs Then
                        astrXML(intXML) = astrXML(intXML) & str12 & "<Subtitle " & strID & "st" & strSubtitleId & "' TitleID='" & strTitleID & _
                           "' SubtitleID='" & strSubtitleId & "' >" & vbCrLf
                     Else
                        astrXML(intXML) = astrXML(intXML) & str12 & "<Subtitle>" & vbCrLf
                     End If
                     astrXML(intXML) = astrXML(intXML) & str15 & strSubtitle & vbCrLf
                     intSp = 15
                  Else
                     strID = strID & "st_"
                     intSp = 9
                  End If
                  astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Chapters>" & vbCrLf
                  intSp = intSp + 3
                  If blnAttribs Then
                     If blnFromTitles Then
                        strID = strID & "ch0"
                     Else
                        strID = strID & "ch" & strChapterId
                     End If
                     astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Chapter " & strID & "sc_' TitleID='" & _
                        strTitleID & "' SubtitleID = '" & strSubtitleId & "' ChapterID = '" & strChapterId & "' >" & vbCrLf
                  Else
                     astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Chapter>" & vbCrLf
                  End If
                  astrXML(intXML) = astrXML(intXML) & Space$(intSp + 3) & strChapter & vbCrLf
                  If blnSubchapter Then
                     strID = strID & "sc" & strSubchapterId
                     intSp = intSp + 3
                     astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Subchapters>" & vbCrLf
                     intSp = intSp + 3
                     If blnAttribs Then
                        astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Subchapter " & strID & "' TitleID='" & _
                           strTitleID & "' SubtitleID = '" & strSubtitleId & "' ChapterID = '" & _
                           strChapterId & "' SubchapterID = '" & strSubchapterId & "' >" & vbCrLf
                     Else
                        astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Subchapter>" & vbCrLf
                     End If
                     astrXML(intXML) = astrXML(intXML) & Space$(intSp + 3) & strSubchapter & vbCrLf
                  Else
                     strID = strID & "sc_"
                  End If
                  intSp = intSp + 3
               End If
            End If
            'Check to see why RTrim$ required here
            astrXML(intXML) = RTrim$(astrXML(intXML)) & Space$(intSp) & "<Parts>" & vbCrLf
            intSp = intSp + 3
         End If
         
         Do While Not .EOF
            'Add the parts
            strPartID = CStr(.Fields(5).Value)
            strItem = strPartID & " - " & CStr(.Fields(6).Value)
            lstParts.AddItem strItem
            If CBool(.Fields(7).Value) = True Or blnNoSectionTest Then
               lstParts.Selected(lstParts.ListCount - 1) = True
            End If
            DoEvents
            If blnAttribs Then
               astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Part " & strID & _
                  "pn" & strPartID & "' TitleID='" & strTitleID & _
                  "' SubtitleID='" & strSubtitleId & "' "
               If blnFromTitles Then
                  astrXML(intXML) = astrXML(intXML) & "ChapterID='0' SubchapterID='-' "
               Else
                  astrXML(intXML) = astrXML(intXML) & "ChapterID='" & strChapterId & _
                     "' SubchapterID='" & strSubchapterId & "' "
               End If
               astrXML(intXML) = astrXML(intXML) & "PartID='" & strPartID & "' HasSections='"
               If CBool(.Fields(7).Value) = True Then
                  astrXML(intXML) = astrXML(intXML) & "Yes' >" & vbCrLf
               ElseIf IsNull(.Fields(7).Value) Then
                  astrXML(intXML) = astrXML(intXML) & "?' >" & vbCrLf
               Else
                  astrXML(intXML) = astrXML(intXML) & "No' >" & vbCrLf
               End If
            Else
               astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "<Part>" & vbCrLf
            End If
            'Temporary until final determination on literal
            strItem = Replace$(strItem, "&", "and")
            astrXML(intXML) = astrXML(intXML) & Space$(intSp + 3) & strItem & vbCrLf
            If blnAddSects Then
               With rstTest
                  If .State = adStateOpen Then
                     .Close
                  End If
                  strSQL = "SELECT * FROM Sections WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' " & _
                     "ORDER BY TitleID, PartIDSort, SectionIDSort"
                  Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
               End With
                                                   
               'Appending the sections string as a chunk improves performance substantially
               With rstTest
                  If Not .EOF Then
                     intSp = intSp + 3
                     strXML = Space$(intSp) & "<Sections>" & vbCrLf
                     Do While Not .EOF
                        strSectID = CStr(.Fields(2).Value)
                        If blnAttribs Then
                           strXML = strXML & Space$(intSp + 3) & "<Section " & strID & "pn" & strPartID & "sn" & strSectID & "' TitleID='" & _
                              strTitleID & "' PartID='" & strPartID & "' SectionID='" & strSectID & _
                              "' Citation='" & strTitleID & "CFR" & strPartID & "." & strSectID & "' HasText='"
                           If CBool(.Fields(4).Value) = True Then
                              strXML = strXML & "Yes' >" & vbCrLf
                           Else
                              strXML = strXML & "No' >" & vbCrLf
                           End If
                        Else
                           strXML = strXML & Space$(intSp + 3) & "<Section>" & vbCrLf
                        End If
                        strXML = strXML & Space$(intSp + 6) & _
                           strPartID & "." & strSectID & " - " & CStr(.Fields(3).Value) & vbCrLf
                        strXML = strXML & Space$(intSp + 3) & "</Section> " & vbCrLf
                        .MoveNext
                     Loop
                     strXML = strXML & Space$(intSp) & "</Sections>" & vbCrLf
                     intSp = intSp - 3
                     DoEvents
                  End If
               End With
               'Only for sections not imported with GetMissingSections
               strXML = Replace$(strXML, "&nbsp;", "")
               strXML = Replace$(strXML, "&hairsp;", "")
               astrXML(intXML) = astrXML(intXML) & strXML
               strXML = ""
            End If
            astrXML(intXML) = astrXML(intXML) & Space$(intSp) & "</Part>" & vbCrLf
            .MoveNext
         Loop
         astrXML(intXML) = astrXML(intXML) & Space$(intSp - 3) & "</Parts>" & vbCrLf
         If blnFromTitles Then
            'Chapters list handles closing tags
            Exit Sub
         End If
      End If
      .Close
      If lstParts.ListCount > 0 And Not blnMakeTOC Then
         lstParts.ListIndex = 0
'         Call lstParts_DblClick
      End If
      If blnAddParts And Not blnOneChap Then
         'Chapters list adds trailers
         Exit Sub
      End If
      If Not blnMakeTOC Then
         If blnSubchapter Then
            If blnSubtitle Then
               astrXML(intXML) = astrXML(intXML) & str24 & "</Subchapter>" & vbCrLf & str21 & "</Subchapters>" & vbCrLf
            Else
               astrXML(intXML) = astrXML(intXML) & str18 & "</Subchapter>" & vbCrLf & str15 & "</Subchapters>" & vbCrLf
            End If
         End If
         If blnSubtitle Then
            astrXML(intXML) = astrXML(intXML) & str18 & "</Chapter>" & vbCrLf & str15 & "</Chapters>" & vbCrLf
            astrXML(intXML) = astrXML(intXML) & str12 & "</Subtitle>" & vbCrLf & str9 & "</Subtitles>" & vbCrLf
         Else
            astrXML(intXML) = astrXML(intXML) & str12 & "</Chapter>" & vbCrLf & str9 & "</Chapters>" & vbCrLf
         End If
         astrXML(intXML) = astrXML(intXML) & str6 & "</Title>" & vbCrLf & str3 & "</Titles>" & vbCrLf & "</CFRToc>"
         
         If InStr(astrXML(intXML), "<Parts>") > 0 Then
            'Check TOC for parse errors
            domDoc.loadXML astrXML(intXML)
            If domDoc.parseError.errorCode <> 0 Then
               Stop
            End If
            'Save the file
            gstrFile = App.Path & "\Parts.xml"
            If Len(Dir(gstrFile)) > 0 Then
               Kill gstrFile
            End If
            Open gstrFile For Binary As #1
            Put #1, , astrXML(intXML)
            Close #1
            
            'Update the chapter or subchapter TOC
            If blnSubchapter Then
               strSQL = "UPDATE Subchapters SET HasTOC = 1, "
            Else
               strSQL = "UPDATE Chapters SET HasTOC = 1, "
            End If
            If Len(astrXML(intXML)) < 7000 Then
               strSQL = strSQL & "TOCText = NULL, TOCChar = '"
            Else
               strSQL = strSQL & "TOCChar = NULL, TOCText = '"
            End If
            strSQL = strSQL & Replace$(astrXML(intXML), "'", "''") & _
               "', TOCLength = " & CStr(Len(astrXML(intXML))) & " WHERE TitleID = " & strTitleID
            If blnSubtitle Then
               strSQL = strSQL & " AND SubtitleID = '" & strSubtitleId & "'"
            End If
            strSQL = strSQL & " AND ChapterID = '" & strChapterId & "'"
            If blnSubchapter Then
               strSQL = strSQL & " AND SubchapterID = '" & strSubchapterId & "'"
            End If
            If blnAddTOC Then
               'Update the Chapters or Subchapters table
               With gcmmCFR
                  .CommandType = adCmdText
                  .CommandText = strSQL
                  .Execute
               End With
            End If
            txtDoc.Text = astrXML(intXML)
         Else
            If Len(strChapXML) > 0 Then
               'Check TOC for parse errors
               domDoc.loadXML strChapXML
               If domDoc.parseError.errorCode <> 0 Then
                  Stop
               End If
               'Save the file
               gstrFile = App.Path & "\Subchapters.xml"
               If Len(Dir(gstrFile)) > 0 Then
                  Kill gstrFile
               End If
               Open gstrFile For Binary As #1
               Put #1, , strChapXML
               Close #1
               txtDoc.Text = strChapXML
               
               'Update the chapter TOC
               strSQL = "UPDATE Chapters SET HasTOC = 1, "
               If Len(strChapXML) < 7000 Then
                  strSQL = strSQL & "TOCChar = '"
               Else
                  strSQL = strSQL & "TOCText = '"
               End If
               strSQL = strSQL & Replace$(strChapXML, "'", "''") & _
                  "', TOCLength = " & CStr(Len(strChapXML)) & " WHERE TitleID = " & strTitleID
               If blnSubtitle Then
                  strSQL = strSQL & " AND SubtitleID = '" & strSubtitleId & "'"
               End If
               strSQL = strSQL & " AND ChapterID = '" & strChapterId & "'"
               If blnAddTOC Then
                  'Update the Chapters or Subchapters table
                  With gcmmCFR
                     .CommandType = adCmdText
                     .CommandText = strSQL
                     .Execute
                  End With
               End If
               txtDoc.Text = strChapXML
            End If
         End If
         astrXML(intXML) = ""
      End If
      If blnGetAllSects Then
         With lstParts
            For intCtr = 0 To .ListCount - 1
               .ListIndex = intCtr
               If Not .Selected(intCtr) Then
                  Call lstParts_DblClick
               End If
            Next intCtr
         End With
      End If
   End With
End Sub

Private Sub lstParts_DblClick()
   'List the sections for the part, retrieving them if necessary
   
   Dim strTitleID As String
   Dim strTitle As String
   Dim strSubtitleId As String
   Dim strSubtitle As String
   
   Dim strChapterId As String
   Dim strChapter As String
   Dim strSubchapterId As String
   Dim strSubchapter As String
   Dim strPartID As String
   Dim strPart As String
   Dim strSectID As String
   Dim strItem As String
   Dim strSectFilter As String
   Dim strSQL As String
   Dim strID As String

   Dim intCtr As Integer
   Dim intIndex As Integer
   Dim intSp As Integer
   
   Dim lngRecord As Long
   
   Dim blnGotSections As Boolean
   Dim blnSubtitle As Boolean
   Dim blnSubchapter As Boolean
   Dim blnFromTitles As Boolean
   
   lstSections.Clear
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   lstParts.ToolTipText = lstParts.List(lstParts.ListIndex)
   
   With lstTitles
      strTitleID = CStr(.ItemData(.ListIndex))
      strID = "ti" & strTitleID
      strTitle = .List(.ListIndex)
      If Val(strTitle) = 0 Then
         strSubtitle = Trim$(strTitle)
         strSubtitleId = Left$(strSubtitle, InStr(strSubtitle, " ") - 1)
         'Id's are only for test; they are recreated later
         strID = strID & "st" & strSubtitleId
         blnSubtitle = True
         'Another way of finding the title or chapter name
         intIndex = .ListIndex
         For intCtr = intIndex To 0 Step -1
            If Left$(.List(intCtr), 1) <> " " Then
               Exit For
            End If
         Next intCtr
         strTitle = UCase$(.List(intCtr))
      Else
         blnSubtitle = False
         strSubtitleId = "-"
         strTitle = UCase$(strTitle)
         strID = strID & "st_"
      End If
      'strTitle = "TITLE " & strTitle
   End With
      
   With lstChapters
      If InStr(.List(0), "no chapters") = 0 Then
         strChapterId = CStr(.ItemData(.ListIndex))
         strChapter = .List(.ListIndex)
         If Left$(strChapter, 1) = " " Then
            strSubchapter = Trim$(strChapter)
            strSubchapterId = Left$(strSubchapter, InStr(strSubchapter, " ") - 1)
            strSubchapter = UCase$(strSubchapter)
            blnSubchapter = True
            intIndex = .ListIndex
            For intCtr = intIndex To 0 Step -1
               If Left$(.List(intCtr), 1) <> " " Then
                  Exit For
               End If
            Next intCtr
            strChapter = .List(intCtr)
            strID = strID & "sc" & strSubchapterId
         Else
            strSubchapterId = "-"
            strID = strID & "sc_"
            blnSubchapter = False
         End If
      Else
         'The title or subtitle has no chapters (special case)
         strChapterId = 0
         strSubchapterId = "-"
         blnFromTitles = True
         blnSubchapter = False
      End If
   End With
   
   With lstParts
      strPart = .List(.ListIndex)
      strPartID = Left$(strPart, InStr(strPart, " ") - 1)
   End With
   
   strSectFilter = "TitleID = '" & strTitleID & "' AND PartID = '" & strPartID & "'"
   With rstSections
      If .State = adStateOpen Then
         .Close
      End If
      strSQL = "SELECT * FROM Sections WHERE " & strSectFilter & _
         " ORDER BY TitleID, PartIDSort, SectionIDSort"
      Set rstSections = gcnnCFR.Execute(strSQL, , adCmdText)
   End With
   With rstSections
      If .EOF Then
         With lstParts
            'Retrieve the sections for the part (needs a fix for eCFR page)
            '.Enabled = False
            'blnGotSections = DownloadSections(strTitleID, strPartID, False)
            '.Enabled = True
            If blnGotSections Then
               .Selected(.ListIndex) = True
            End If
            DoEvents
         End With
         If .State = adStateOpen Then
            .Close
         End If
         strSQL = "SELECT TitleID, PartID, SectionID, Section, HasText FROM Sections WHERE " & strSectFilter & _
            " ORDER BY TitleID, PartIDSort, SectionIDSort"
         Set rstSections = gcnnCFR.Execute(strSQL, , adCmdText)
      End If
   End With
   With rstSections
      If Not .EOF Then
         'Add the full header for the sections
         strID = "id='ti" & strTitleID
         strXML = gstrXMLPrefix & gstrCFRToc & str3 & "<Titles>" & vbCrLf
         If blnAttribs Then
            strXML = strXML & str6 & "<Title " & strID & "st_' TitleID='" & strTitleID & "' >" & vbCrLf
         Else
            strXML = strXML & str6 & "<Title>" & vbCrLf
         End If
         strXML = strXML & str9 & strTitle & vbCrLf
         'If blnFromTitles Then
            'Use the short-form ID for the attribute
            'ti#pn#sn# instead of ti#st#ch#sc#pn#sn#
         'Else
            If blnSubtitle Then
               strID = strID & "st" & strSubtitleId
               strXML = strXML & str9 & "<Subtitles>" & vbCrLf
               If blnAttribs Then
                  strXML = strXML & str12 & "<Subtitle " & strID & "' TitleID='" & strTitleID & _
                     "' SubtitleID='" & strSubtitleId & "' >" & vbCrLf
               Else
                  strXML = strXML & str12 & "<Subtitle>" & vbCrLf
               End If
               strXML = strXML & str15 & strSubtitle & vbCrLf
               intSp = 15
            Else
               strID = strID & "st_"
               intSp = 9
            End If
            'added
         If blnFromTitles Then
            'Add the null chapter and subchapter
            strID = strID & "ch0sc_"
         Else
            strXML = strXML & Space$(intSp) & "<Chapters>" & vbCrLf
            intSp = intSp + 3
            strID = strID & "ch" & strChapterId
            If blnAttribs Then
               strXML = strXML & Space$(intSp) & "<Chapter " & strID & "sc_' TitleID='" & _
                  strTitleID & "' SubtitleID='" & strSubtitleId & "' ChapterID='" & strChapterId & "' >" & vbCrLf
            Else
               strXML = strXML & Space$(intSp) & "<Chapter>" & vbCrLf
            End If
            intSp = intSp + 3
            strXML = strXML & Space$(intSp) & strChapter & vbCrLf
            If blnSubchapter Then
               strID = strID & "sc" & strSubchapterId
               intSp = intSp + 3
               strXML = strXML & Space$(intSp) & "<Subchapters>" & vbCrLf
               intSp = intSp + 3
               If blnAttribs Then
               strXML = strXML & Space$(intSp) & "<Subchapter " & strID & " ' TitleID='" & _
                  strTitleID & "' SubtitleID='" & strSubtitleId & "' ChapterID='" & _
                  strChapterId & "' SubchapterID='" & strSubchapterId & "' >" & vbCrLf
               Else
                  strXML = strXML & Space$(intSp) & "<Subchapter>" & vbCrLf
               End If
               strXML = strXML & Space$(intSp + 3) & strSubchapter & vbCrLf
            Else
               strID = strID & "sc_"
            End If
            intSp = intSp + 3
         End If
         'Check to see why RTrim$ required here
         strXML = strXML & Space$(intSp) & "<Parts>" & vbCrLf
         intSp = intSp + 3
         strID = strID & "pn" & strPartID
         If blnAttribs Then
            strXML = strXML & Space$(intSp) & "<Part " & strID & "' TitleID='" & _
               strTitleID & "' SubtitleID='" & strSubtitleId & "' ChapterID='" & _
               strChapterId & "' SubchapterID='" & strSubchapterId & _
               "' PartID='" & strPartID & "' >" & vbCrLf
         Else
            strXML = strXML & Space$(intSp) & "<Part>" & vbCrLf
         End If
         intSp = intSp + 3
         'One part has an &
         strXML = strXML & Space$(intSp) & Replace$(strPart, "&", "and") & vbCrLf
         strXML = strXML & Space$(intSp) & "<Sections>" & vbCrLf
         intSp = intSp + 3
         Do While Not .EOF
            strItem = CStr(.Fields(1).Value) & "." & CStr(.Fields(2).Value) & " - " & CStr(.Fields(3).Value)
            'A few original section titles have literals
            strItem = Replace$(strItem, "&nbsp;", "")
            strItem = Replace$(strItem, "&hairsp;", "")
            With lstSections
               .AddItem strItem
               If CBool(rstSections.Fields(4).Value) = True Then
                  If IsNull(rstSections.Fields(5)) Then
                     If Not IsNull(rstSections.Fields(11)) Then
                        'XML text is present
                        .Selected(.ListCount - 1) = True
                        DoEvents
                     End If
                  Else
                     'XML text is present
                     .Selected(.ListCount - 1) = True
                     DoEvents
                  End If
               End If
            End With
            If blnAttribs Then
               strSectID = Mid$(strItem, InStr(strItem, ".") + 1)
               strSectID = Left$(strSectID, InStr(strSectID, " ") - 1)
               
               strXML = strXML & Space$(intSp) & "<Section " & strID & "sn" & strSectID & "' TitleID='" & _
                  strTitleID & "' PartID='" & strPartID & "' SectionID='" & strSectID & _
                  "' Citation='" & strTitleID & "CFR" & strPartID & "." & strSectID & "' HasText='"
               If CBool(.Fields(4).Value) = True Then
                  strXML = strXML & "Yes' >" & vbCrLf
               Else
                  strXML = strXML & "No' >" & vbCrLf
               End If
            Else
               strXML = strXML & Space$(intSp) & "<Section>" & vbCrLf
            End If
            strXML = strXML & Space$(intSp + 3) & Replace$(strItem, "&", "and") & vbCrLf
            strXML = strXML & Space$(intSp) & "</Section>" & vbCrLf
            DoEvents
            .MoveNext
         Loop
         
         'Close all the tags
         intSp = intSp - 3
         strXML = strXML & Space$(intSp) & "</Sections>" & vbCrLf
         intSp = intSp - 3
         strXML = strXML & Space$(intSp) & "</Part>" & vbCrLf
         intSp = intSp - 3
         strXML = strXML & Space$(intSp) & "</Parts>" & vbCrLf
         If blnFromTitles Then
            'Stop
         Else
            If blnSubchapter Then
               If blnSubtitle Then
                  strXML = strXML & str24 & "</Subchapter>" & vbCrLf & str21 & "</Subchapters>" & vbCrLf
               Else
                  strXML = strXML & str18 & "</Subchapter>" & vbCrLf & str15 & "</Subchapters>" & vbCrLf
               End If
            End If
         End If
         If blnSubtitle Then
            If Not blnFromTitles Then
               strXML = strXML & str18 & "</Chapter>" & vbCrLf & str15 & "</Chapters>" & vbCrLf
            End If
            strXML = strXML & str12 & "</Subtitle>" & vbCrLf & str9 & "</Subtitles>" & vbCrLf
            'End If
         Else
            If Not blnFromTitles Then
               strXML = strXML & str12 & "</Chapter>" & vbCrLf & str9 & "</Chapters>" & vbCrLf
            End If
         End If
         strXML = strXML & str6 & "</Title>" & vbCrLf & str3 & "</Titles>" & vbCrLf & "</CFRToc>"
         txtDoc.Text = strXML
         'Check TOC for parse errors
         domDoc.loadXML strXML
         If domDoc.parseError.errorCode <> 0 Then
            Stop
         End If
         'Save XML in a text file
         gstrFile = App.Path & "\SectionsTOC.xml"
         If Len(Dir(gstrFile)) > 0 Then
            Kill gstrFile
         End If
         Open gstrFile For Binary As #1
         Put #1, , strXML
         Close #1
         txtDoc.Text = strXML
         If blnAddTOC Then
            strSQL = "UPDATE Parts SET HasTOC = 1, "
            If Len(strXML) < 7000 Then
               strSQL = strSQL & "TOCText = NULL, TOCChar = '"
            Else
               strSQL = strSQL & "TOCChar = NULL, TOCText = '"
            End If
            'Update the Parts table
            strSQL = strSQL & Replace$(strXML, "'", "''") & _
               "', TOCLength = " & CStr(Len(strXML)) & _
               " WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "'"
            With gcmmCFR
               .CommandType = adCmdText
               .CommandText = strSQL
               .Execute
            End With
         End If
         strXML = ""
      End If
   End With
   With lstSections
      If .ListCount Then
         .ListIndex = 0
         DoEvents
      End If
   End With
End Sub

Private Sub lstSections_DblClick()
   'Retrieve and display a section
   Dim strTitleID As String
   Dim strPartID As String
   Dim strSectID As String
   Dim strItem As String
   Dim strSectFilter As String
   Dim strMsg As String
   Dim strTemp As String
   Dim strSQL As String
   Dim strDoc As String
   Dim strAppURL As String
   
   Dim intDocError As Integer
   
   Dim intMsgBox As Integer
   
   If blnGetAllDocs Then
      Exit Sub
   End If
   
   lstSections.ToolTipText = lstSections.List(lstSections.ListIndex)
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   DoEvents
      
   intDocError = 1   'Any non-zero value will do
   strTitleID = CStr(lstTitles.ItemData(lstTitles.ListIndex))
   strItem = lstSections.List(lstSections.ListIndex)
   strItem = Left$(strItem, InStr(strItem, " ") - 1)
   strPartID = Left$(strItem, InStr(strItem, ".") - 1)
   strSectID = Mid$(strItem, InStr(strItem, ".") + 1)
   
   strSectFilter = "TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectID & "'"
   
   If chkGetDoc.Value = 1 Then
      txtDoc.Text = ""
      If Left$(strSectID, 3) = "App" Then
         'It's an appendix, so the URL is required
         strSQL = "SELECT SourceURL FROM Sections WHERE " & strSectFilter
         With rstSections
            If .State = adStateOpen Then
               .Close
            End If
         End With
         Set rstSections = gcnnCFR.Execute(strSQL, , adCmdText)
         With rstSections
            If .EOF Then
               'error
            Else
               strAppURL = CStr(.Fields(0).Value)
            End If
         End With
      End If
      intDocError = UpdateSectionTextUI(strTitleID, strPartID, strSectID, strAppURL, True)
      If intDocError = 0 Then
         lstSections.Selected(lstSections.ListIndex) = True
      Else
         lstSections.Selected(lstSections.ListIndex) = False
      End If
      DoEvents
   Else
      
      With rstSections
         If .State = adStateOpen Then
            .Close
         End If
         'Below needs fixing to return only required fields
         strSQL = "SELECT * FROM Sections WHERE " & strSectFilter & _
            " ORDER BY TitleID, PartIDSort, SectionIDSort"
         Set rstSections = gcnnCFR.Execute(strSQL, , adCmdText)
      End With
      With rstSections
         If .EOF Then
            'Error
            Stop
         Else
            If CBool(.Fields(4).Value) = True Then
               If IsNull(.Fields(5).Value) Then
                  txtDoc.Text = CStr(.Fields(11).Value)
               Else
                  txtDoc.Text = CStr(.Fields(5).Value)
               End If
               intDocError = 0
               DoEvents
               lstSections.Selected(lstSections.ListIndex) = True
               'Save a text file
               strTemp = gstrXMLPrefix & txtDoc.Text
               gstrFile = App.Path & "\Section.xml"
               If Len(Dir(gstrFile)) > 0 Then
                  Kill gstrFile
               End If
               Open gstrFile For Binary As #1
               Put #1, , strTemp
               Close #1
            End If
         End If
         If intDocError <> 0 Then
            lstSections.Selected(lstSections.ListIndex) = False
            DoEvents
            strMsg = "The XML document for Title " & strTitleID & ", Section " & _
               strItem & " is missing or not in XML format." & vbCrLf & vbCrLf & _
               "Do you want to download the document from the USGPO and format it?"
               intMsgBox = MsgBox(strMsg, vbYesNo + vbQuestion, "Download the Document?")
            If intMsgBox = vbYes Then
               DoEvents
               txtDoc.Text = ""
               intDocError = UpdateSectionTextUI(strTitleID, strPartID, strSectID, strAppURL, True)
               If intDocError = 0 Then
                  lstSections.Selected(lstSections.ListIndex) = True
               Else
                  lstSections.Selected(lstSections.ListIndex) = False
               End If
               DoEvents
            End If
         End If
         .Close
      End With
   End If
   cmdGetAllDocs.Enabled = True
End Sub

Private Sub txtDoc_DblClick()
   'Displays XML text in IE 5.5+ or Notepad
   If Len(gstrFile) > 0 Then
      If blnOpenInNotepad Then
         dblShell = Shell("Notepad.exe " & gstrFile, vbMaximizedFocus)
      Else
         dblShell = Shell("\Program Files\Internet Explorer\Iexplore.exe " & gstrFile, vbMaximizedFocus)
      End If
   End If
End Sub

Private Sub cmdGetSects_Click()
   'Scrape eCFR browse page for all chapters to get parts, then get current sections
   'The eCFR database is updated more frequently than the original WAIS source used
   Dim rstTest As New ADODB.Recordset
   
   Dim strURLPrefix As String
   Dim strURL As String
   Dim strURLSuffix As String
   Dim strTitleURL As String
   Dim strChapURL As String
   Dim strPartURL As String
   Dim strSectURL As String
   Dim strAppURL As String
   Dim strHTML As String
   Dim strTitleHTML As String
   Dim strChapHTML As String
   Dim strPartHTML As String
   Dim strSectHTML As String
   Dim strText As String
   Dim strTemp As String
   Dim strSQL As String
   Dim strWhere As String

   Dim strSubtitle As String
   Dim strTitle As String
   Dim strChapter As String
   Dim strSubchapter As String
   Dim strPart As String
   Dim strSection As String
   Dim strTitleID As String
   Dim strSubtitleId As String
   Dim strChapterId As String
   Dim strSubchapterId As String
   Dim strPartID As String
   Dim strPartIdx As String
   Dim strSectionID As String
   Dim strSectIdx As String
   Dim strAppID As String
   Dim strLastPart As String
      
   Dim intTitle As Integer
   Dim intCtr As Integer
   Dim intLastPart As Integer
   
   Dim blnTitleDone As Boolean
   Dim blnClearTextBox As Boolean
   Dim blnUpdateVerified As Boolean
   
   On Error GoTo 0
   
   strMsg = "This process iterates the Chapters and Subchapters tables to find " & _
            "missing parts and sections, and then add them (by scraping the e-CFR " & _
            "database's search pages) to the Parts and Sections tables. " & _
            "The process requires a very long time to populate the tables, " & _
            "but you can halt the process at any point. Restarting the process, " & _
            "however, tests every entry, so it's recommended you run to completion." & vbCrLf & vbCrLf & _
            "After you add the entries, click Add All TOCs to generate tables of " & _
            "contents for the added parts and sections, which also takes a while." & _
            "You must click Add All Text to retrieve the section text for the added sections." & vbCrLf & vbCrLf & _
            "Click Yes to continue, No to cancel."
   If MsgBox(strMsg, vbQuestion + vbYesNo, "Add Missing Parts and Sections") <> vbYes Then
      Exit Sub
   End If
   
   Me.MousePointer = vbHourglass
   Call ButtonState(False)
   cmdHalt.Enabled = True
   blnHalt = False
   txtDoc.Text = "Starting Missing Part and Section Test" & vbCrLf
   strText = ""
   DoEvents
   For intTitle = 1 To 50
      If intTitle = 2 Or intTitle = 6 Then
         'Titles 2 and 6 are reserved
         intTitle = intTitle + 1
      End If
      strTitleID = CStr(intTitle)
      strURLPrefix = "http://www.access.gpo.gov"
      strURL = "/nara/cfr/cfrhtml_00/Title_" & CStr(intTitle) & "/"
      strTitleURL = strURLPrefix & strURL & CStr(intTitle) & "tab_00.html"
      'Title: http://www.access.gpo.gov/nara/cfr/cfrhtml_00/Title_1/1tab_00.html
      strTitleHTML = GetHTMLFromURL(strTitleURL)
         
      If InStr(strTitleHTML, strURL) > 0 Then
         Do While InStr(strTitleHTML, strURL) > 0
         
            strTemp = Mid$(strTitleHTML, InStr(strTitleHTML, strURL))
            strChapURL = strURLPrefix & Left$(strTemp, InStr(strTemp, Chr$(34)) - 1)
            'Volume: http://www.access.gpo.gov/nara/cfr/cfrhtml_00/Title_1/1cfrv1_00.html
            'Some pages have URLs with bogus #101 trailers
            If InStr(strChapURL, "#") > 0 Then
               strChapURL = Left$(strChapURL, InStr(strChapURL, "#") - 1)
            End If
            strChapHTML = GetHTMLFromURL(strChapURL)
            If InStr(strChapHTML, "<!--") > 0 Then
               'Remove the comments at the end
               strChapHTML = Left$(strChapHTML, InStr(strChapHTML, "<!--") - 1)
            End If
            DoEvents
            
            'Reinitialize the WHERE variables
            strSubtitleId = "-"
            strSubtitle = ""
            strChapterId = "-"
            strChapter = ""
            strSubchapterId = "-"
            strSubchapter = ""
            strPartID = "-"
            strPart = ""
            
            strChapHTML = Replace$(strChapHTML, "&nbsp;", "")
            strChapHTML = Replace$(strChapHTML, vbLf, "")
            intLastPart = 0
            strLastPart = "0"
            
            Do While InStr(strChapHTML, strURL) > 0
               strTemp = Mid$(strChapHTML, InStr(strChapHTML, strURL))
               strPartURL = strURLPrefix & Left$(strTemp, InStr(strTemp, Chr$(34)) - 1)
               If InStr(strPartURL, "tab_") > 0 Then
                  'Reached the end of the title
                  blnTitleDone = True
                  Exit Do
               End If
               
               'Find subtitle
               If InStr(UCase$(strChapHTML), ">SUBTITLE") > 0 Then
                  If InStr(UCase$(strChapHTML), ">SUBTITLE") < InStr(strChapHTML, strURL) Then
                     strChapHTML = Trim$(Mid$(strChapHTML, InStr(UCase$(strChapHTML), ">SUBTITLE") + 9))
                     strSubtitleId = Left$(strChapHTML, InStr(strChapHTML, "--") - 1)
                     strSubtitle = Mid$(strChapHTML, InStr(strChapHTML, "--") + 2)
                     strSubtitle = Trim$(Left$(strSubtitle, InStr(strSubtitle, "<") - 1))
                     strSubtitle = Replace$(strSubtitle, vbLf, "")
                  End If
               End If
               
               'Find chapter
               If InStr(UCase$(strChapHTML), ">CHAPTER") > 0 Then
                  If InStr(UCase$(strChapHTML), ">CHAPTER") < InStr(strChapHTML, strURL) Then
                     strChapHTML = Trim$(Mid$(strChapHTML, InStr(UCase$(strChapHTML), ">CHAPTER") + 8))
                     strChapterId = Left$(strChapHTML, InStr(strChapHTML, "--") - 1)
                     If Val(strChapterId) = 0 Then
                        'Title 48 has numeric chapter numbers
                        strChapterId = Roman2Arabic(strChapterId)
                     End If
                     strChapter = Mid$(strChapHTML, InStr(strChapHTML, "--") + 2)
                     strChapter = Trim$(Left$(strChapter, InStr(strChapter, "<") - 1))
                     strChapter = Replace$(strChapter, vbLf, "")
                     strChapter = ToILC(strChapter)
                     'Reset the subchapter
                     strSubchapterId = "-"
                     strSubchapter = ""
                  End If
               End If
               
               'Skip reserved subchapters
               intCtr = 0
               Do While InStr(UCase$(strChapHTML), ">SUBCHAPTER") > 0
                  If InStr(UCase$(strChapHTML), ">SUBCHAPTER") < InStr(strChapHTML, strURL) Then
                     strChapHTML = Trim$(Mid$(strChapHTML, InStr(UCase$(strChapHTML), ">SUBCHAPTER") + 11))
                     strSubchapterId = Left$(strChapHTML, InStr(strChapHTML, "--") - 1)
                     If InStr(UCase$(strSubchapterId), "[RESERVED]") = 0 Then
                        strSubchapter = Mid$(strChapHTML, InStr(strChapHTML, "--") + 2)
                        strSubchapter = Trim$(Left$(strSubchapter, InStr(strSubchapter, "<") - 1))
                        strSubchapter = Replace$(strSubchapter, vbLf, "")
                        Exit Do
                     Else
                        'Stop
                        strChapHTML = Trim$(Mid$(strChapHTML, InStr(UCase$(strChapHTML), ">SUBCHAPTER")))
                     End If
                  End If
                  intCtr = intCtr + 1
                  If intCtr > 2 Then
                     'Safety net
                     Exit Do
                  End If
               Loop
               DoEvents
               
               'Get the eCFR main page with sections for the parts
               strTemp = Mid$(strPartURL, InStrRev(strPartURL, "cfr") + 3)
               'Frameset: http://www.access.gpo.gov/nara/cfr/cfrhtml_00/Title_1/1cfr1_00.html
               'Main page: http://www.access.gpo.gov/nara/cfr/cfrhtml_00/Title_1/1cfr1_main_00.html
               strTemp = Mid$(strPartURL, InStrRev(strPartURL, "/"))
               strPartURL = Left$(strPartURL, InStrRev(strPartURL, "/") - 1)
               strTemp = Replace$(strTemp, "_", "_main_")
               strPartURL = strPartURL & strTemp
               strPartHTML = GetHTMLFromURL(strPartURL)
               If InStr(strPartHTML, "<!--") > 0 Then
                  'Remove the comments at the end
                  strPartHTML = Left$(strPartHTML, InStr(strPartHTML, "<!--") - 1)
               End If
               DoEvents
                             
               'Title 42 has "PART 63a_NATIONAL...", apparently a typo (s/b "--")
               'and has appendices at the end with <APP> tags
               'strPartHTML = Replace$(strPartHTML, "_", " ")
               If InStr(UCase$(strPartHTML), ">PART") > 0 Or InStr(UCase$(strPartHTML), ">APP.") > 0 Then
                  'This should always be present
                  If InStr(UCase$(strPartHTML), ">PART") > 0 Then
                     strPartHTML = Trim$(Mid$(strPartHTML, InStr(UCase$(strPartHTML), ">PART") + 5))
                  Else
                     strPartHTML = Trim$(Mid$(strPartHTML, InStr(UCase$(strPartHTML), ">APP.") + 5))
                  End If
                  If InStr(strPartHTML, "--") > 0 Then
                     strPartID = Left$(strPartHTML, InStr(strPartHTML, "--") - 1)
                     strPart = Mid$(strPartHTML, InStr(strPartHTML, "--") + 2)
                  Else
                     'Title 42 Part 63a problem
                     If InStr(strPartHTML, "_") > 0 Then
                        'Title 42 fix
                        strPartID = Left$(strPartHTML, InStr(strPartHTML, "_") - 1) + " "
                        strPart = Mid$(strPartHTML, InStr(strPartHTML, "_") + 1)
                     Else
                        strPartID = Left$(strPartHTML, InStr(strPartHTML, " ") - 1)
                        If InStr(strPart, " ") > 0 Then
                           strPart = Mid$(strPartHTML, InStr(strPartHTML, " ") + 1)
                        End If
                     End If
                  End If
                  
                  If InStr(strPart, "<") > 0 Then
                     strPart = Trim$(Left$(strPart, InStr(strPart, "<") - 1))
                  End If
                  strPart = Replace$(strPart, vbLf, "")
                  If InStr(UCase$(strPart), "[RESERVED]") > 0 Then
                     strPart = "[Reserved]"
                  Else
                     strPart = ToILC(strPart)
                  End If
                  intLastPart = Val(strPartID)
                  strLastPart = strPartID
               Else
                  If InStr(UCase$(strPartHTML), "NOT FOUND") > 0 Then
                     strPartID = "x"
                  Else
                     Call OpenFile(strPartHTML, "BadPart.txt")
                     Stop
                  End If
               End If
               
               If Len(strPartID) > 5 Then
                  'Temporary for test
                  'Stop
               End If
               
               'Now test for existence of the part
               With rstTest
                  If .State = adStateOpen Then
                     .Close
                  End If
               End With
               
               If strChapterId = "-" Then
                  'Parts without chapters (e.g., Title 7)
                  strChapterId = "0"
               End If
               
               strWhere = "WHERE TitleID = " & strTitleID & _
                  " AND SubtitleID = '" & strSubtitleId & "' AND ChapterID = " & _
                  strChapterId & " AND SubchapterID = '" & strSubchapterId & _
                  "' AND PartID = '" & strPartID & "'"
               
               strSQL = "SELECT Part, Verified FROM Parts " & strWhere
               
               'Test for existence of part
               Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
               strTemp = "Title " & strTitleID & " Subtitle " & strSubtitleId & _
                  " Chapter " & strChapterId & " Subchapter " & strSubchapterId & _
                  " Part " & strPartID
               With rstTest
                  If .EOF Then
                     'It's missing
                     If strPartID = "x" Then
                        strTemp = strTemp & " wasn't found" & vbCrLf
                     Else
                        If Len(txtDoc.Text) > 55000 Then
                           txtDoc.Text = "Resetting text box" & vbCrLf
                        End If
                        txtDoc.Text = txtDoc.Text & strTemp & vbCrLf
                        strText = strText & strTemp & " is missing" & vbCrLf
                     End If
                           
                     'SQL for the insert
                     strSQL = "INSERT Parts(TitleID, SubtitleID, ChapterID, SubchapterID, GroupOrPartsID, PartID, " & _
                        "Part, HasSections, HasTOC, Verified) VALUES(" & strTitleID & ", '" & strSubtitleId & "', " & _
                        strChapterId & ", '" & strSubchapterId & "', '-', '" & strPartID & "', '" & Replace$(strPart, "'", "''") & _
                        "', "
                     If strPart = "[Reserved]" Or strPart = "[RESERVED]" Then
                        'No sections
                        strSQL = strSQL & "0, 0, 1)"
                     Else
                        'Will have sections
                        strSQL = strSQL & "1, 0, 1)"
                     End If
                     With gcmmCFR
                        .CommandType = adCmdText
                        .CommandText = strSQL
                        .Execute
                     End With
                  Else
                     If Len(txtDoc.Text) > 500 Then
                        txtDoc.Text = "Resetting text box" & vbCrLf
                     End If
                     txtDoc.Text = txtDoc.Text & "Verified " & strTemp & vbCrLf
                     If CBool(.Fields(1).Value) = False Or (CBool(.Fields(1).Value) = True And blnUpdateVerified) Then
                        'SQL to update name change
                        strSQL = "UPDATE Parts SET Part = '" & Replace(strPart, "'", "''") & "', Verified = 1 " & strWhere
                        With gcmmCFR
                           .CommandType = adCmdText
                           .CommandText = strSQL
                           .Execute
                        End With
                     End If
                  End If
                  .Close
                  Set rstTest = Nothing
               End With
               DoEvents
               
               strSectURL = "http://frwebgate.access.gpo.gov/cgi-bin/DBSearch.cgi?"
               Do While InStr(strPartHTML, strSectURL)
                  'Loop through all the parts for the chapter or subchapter
                  'SELECT Section FROM Sections WHERE TitleID = 28 AND PartID = '42' AND SectionID = '28D--OJARS'(2842'
                  
                  strAppURL = ""
                  strPartHTML = Mid$(strPartHTML, InStr(strPartHTML, strSectURL) + Len(strSectURL) + 1)
                  
                  strSectionID = Mid$(strPartHTML, InStr(strPartHTML, "QUERY=") + 6)
                  strSectionID = Left$(strSectionID, InStr(strSectionID, "&") - 1)
                  strSectionID = Mid$(strSectionID, InStr(strSectionID, ".") + 1)
                  If InStr(strSectionID, "2842") > 0 Then
                     'Temporary for test
                     'Stop
                  End If
                  
                  'Get the section name
                  strPartHTML = Mid$(strPartHTML, InStr(strPartHTML, "<FONT size=""2"">") + 15)
                  strSection = Trim$(Left$(strPartHTML, InStr(strPartHTML, "</FONT>") - 1))
                  strSection = Replace$(strSection, vbLf, "")
                  
                  'Determine if the section is an appendix
                  If InStr(strSection, "Appendix") > 0 Then
                     'The URL provided in the section for appendices is:
                     'http://frwebgate.access.gpo.gov/cgi-bin/DBSearch.cgi?DBSearchDB=ecfr&DB=1&ACTION=View&QUERY=4&RGN=BTI&OP=and&QUERY=83&RGN=BPT&OP=and&QUERY=1923&RGN=BAPPCT&SUBSET=SUBSET&FROM=1&ITEM=1
                     
                     'This redirects to the following URL and returns HTML (the preceding might change)
                     'http://ecfrback.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=1&ACTION=View&QUERY=4&RGN=BTI&OP=and&QUERY=83&RGN=BPT&OP=and&QUERY=1923&RGN=BAPPCT&SUBSET=SUBSET&FROM=1&ITEM=1
                     
                     'The following change returns SGML
                     'http://ecfr.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0&ACTION=ViewNative&QUERY=4&RGN=BTI&OP=and&QUERY=83&RGN=BPT&OP=and&QUERY=1923&RGN=BAPPCT&SUBSET=SUBSET&FROM=1&ITEM=1
                     
                     If InStr(strSection, "<") > 0 Then
                        If InStr(strSection, "http://") > 0 Then
                           strAppURL = Mid$(strSection, InStr(strSection, "http://"))
                           strAppURL = Trim$(Left$(strAppURL, InStr(strAppURL, Chr$(34)) - 1))
                           If InStr(strAppURL, "http://frwebgate") > 0 And InStr(strAppURL, "DBSearchDB=ecfr&DB=1") > 0 Then
                              strAppURL = Mid$(strAppURL, InStr(strAppURL, "DBSearchDB=ecfr&DB=1") + 20)
                              strAppURL = "http://ecfr.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0" & strAppURL
                              strAppURL = Replace$(strAppURL, "View", "ViewNative")
                           Else
                              'Check for removal of redirect
                           End If
                           
                           'Fabricate a unique section ID for the appendix
                           'Section ID is App[+SubpartChar[+AppendixChar]]
                           strSection = Mid$(strSection, InStr(strSection, "Appendix ") + 9)
                           If InStr(strSection, "</A>") Then
                              strSection = Replace$(strSection, "</A>", "")
                              If InStr(strSection, "--") > 0 Then
                                 strSection = Replace(strSection, "--", " - ")
                              ElseIf InStr(strSection, "-") > 0 Then
                                 'Typo in Part 43
                                 strSection = Replace(strSection, "-", " - ")
                              End If
                           End If
                           
                           strAppID = Trim$(Left$(strSection, InStr(strSection, " ")))
                           strSection = "Appendix " & strSection
                           If InStr(strAppID, "--") > 0 Then
                              'Some appendix names don't contain SubPart or Part
                              strAppID = Left$(strAppID, InStr(strAppID, "--") - 1)
                           End If
                           
                           If InStr(UCase$(strSection), "SUBPART ") > 0 Then
                              strTemp = Mid$(strSection, InStr(UCase$(strSection), "SUBPART ") + 8)
                              strTemp = Trim$(Left$(strTemp, InStr(strTemp, " ")))
                              'strSectionID = strSectionID & strTemp
                              strAppID = strTemp & strAppID
                           End If
                           
                           strSectionID = "App" & strAppID
                        Else
                           'It's something else; don't process it
                        End If
                     End If
                  End If
                  If InStr(strSection, ">") > 0 Then
                     strSection = Mid$(strSection, InStr(strSection, ">") + 1)
                     strSection = Replace$(strSection, "</A>", "")
                     strSection = Replace$(strSection, "--", " - ")
                     strSection = Replace$(strSection, "  ", " ")
                  End If
                  
                  'Remove any LF chars
                  strSectionID = Replace(strSectionID, vbLf, "")
                  strSection = Replace(strSection, vbLf, "")
                  'For unknown reasons, title 12 uses CR, not LF
                  strSectionID = Replace(strSectionID, vbCr, "")
                  strSection = Replace(strSection, vbCr, "")
                  
                  'In some cases "to" appears in section ID (hack)
                  strSectionID = Replace(strSectionID, "to", "")
                  
                  'Following occurs occasionally
                  strSectionID = Replace(strSectionID, "[Reserved]", "")
                  strSectionID = Replace(strSectionID, "[RESERVED]", "")
                  
                  'Typical problem: Appendix to Subpart ''Imported Fire Ant''
                  If Len(strSectionID) < 11 Then
                     'Skip problem appendices
                     strPartHTML = Mid$(strPartHTML, InStr(strPartHTML, "</FONT>") + 7)
                     With rstTest
                        If .State = adStateOpen Then
                           .Close
                        End If
                     End With
                     strWhere = "WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectionID & "'"
                     strSQL = "SELECT Section, Verified FROM Sections " & strWhere
                     Set rstTest = gcnnCFR.Execute(strSQL, , adCmdText)
                     strTemp = "Title " & strTitleID & " Part " & strPartID & " Section " & strSectionID & " '" & strSection & "' is missing"
                     With rstTest
                        If .EOF Then
                           'It's missing, add it
                           If Len(txtDoc.Text) > 5000 Then
                              txtDoc.Text = "Resetting text" & vbCrLf
                           End If
                           txtDoc.Text = txtDoc.Text & strTemp & vbCrLf
                           strText = strText & strTemp & vbCrLf
                           
                           'Create the part index value
                           If Val(strPartID) < 10 Then
                              strPartIdx = "000" & strPartID
                           ElseIf Val(strPartID) < 100 Then
                              strPartIdx = "00" & strPartID
                           ElseIf Val(strPartID) < 1000 Then
                              strPartIdx = "0" & strPartID
                           Else
                              strPartIdx = strPartID
                           End If
                           
                           'Create the section index value
                           strSectIdx = strSectionID
                           If Left$(strSectIdx, 3) <> "App" Then
                              If Val(strSectIdx) < 10 Then
                                 strSectIdx = "000" & strSectIdx
                              ElseIf Val(strSectIdx) < 100 Then
                                 strSectIdx = "00" & strSectIdx
                              ElseIf Val(strSectIdx) < 1000 Then
                                 strSectIdx = "0" & strSectIdx
                              Else
                                 strSectIdx = strSectIdx
                              End If
                           End If
                           
                           'SQL for adding the section
                           strSQL = "INSERT Sections(TitleID, PartID, SectionID, Section, HasText, PartIDSort, " & _
                              "SectionIDSort, DateRevised, "
                           If Len(strAppURL) > 0 Then
                              strSQL = strSQL & "SourceURL, "
                           End If
                           strSQL = strSQL & " Verified) VALUES(" & strTitleID & ", '" & strPartID & "', '" & _
                              strSectionID & "', '" & Replace$(strSection, "'", "''") & "', 0, '" & strPartIdx & "', '" & strSectIdx
                           If Len(strAppURL) > 0 Then
                              strSQL = strSQL & "', '1/1/1980', '" & strAppURL & "', 0)"
                           Else
                              strSQL = strSQL & "', '1/1/1980', 0)"
                           End If
                           
                           On Error Resume Next
                           intCtr = 0
                           Do
                              'Loop to handle errors from duplicate appendix key
                              Err.Clear
                              With gcmmCFR
                                 .CommandType = adCmdText
                                 .CommandText = strSQL
                                 .Execute
                              End With
                              If Err.Number = 0 Then
                                 Exit Do
                              Else
                                 'Fixup for duplicate key
                                 intCtr = intCtr + 1
                                 strSectIdx = strSectIdx & CStr(intCtr)
                                 strSQL = "INSERT Sections(TitleID, PartID, SectionID, Section, HasText, PartIDSort, " & _
                                    "SectionIDSort, DateRevised, "
                                 If Len(strAppURL) > 0 Then
                                    strSQL = strSQL & "SourceURL, "
                                 End If
                                 strSQL = strSQL & " Verified) VALUES(" & strTitleID & ", '" & strPartID & "', '" & _
                                    strSectionID & "', '" & Replace$(strSection, "'", "''") & "', 0, '" & strPartIdx & "', '" & strSectIdx
                                 If Len(strAppURL) > 0 Then
                                    strSQL = strSQL & "', '1/1/1980', '" & strAppURL & "', 0)"
                                 Else
                                    strSQL = strSQL & "', '1/1/1980', 0)"
                                 End If
                              End If
                              If intCtr > 8 Then
                                 'Safety net
                                 Exit Do
                              End If
                           Loop
                           With gcmmCFR
                              .CommandType = adCmdText
                              .CommandText = strSQL
                              '.Execute
                           End With
                           If Err.Number <> 0 Then
                              Stop
                           End If
                        Else
                           If CBool(.Fields(1).Value) = False Or (CBool(.Fields(1).Value) = True And blnUpdateVerified) Then
                              'It's there, update the name
                              strSQL = "UPDATE Sections SET Section = '" & Replace$(strSection, "'", "''") & "', Verified = 1"
                              If Len(strAppURL) > 0 Then
                                 strSQL = strSQL & ", SourceURL = '" & strAppURL & "'"
                              End If
                              strSQL = strSQL & " " & strWhere
                              With gcmmCFR
                                 .CommandType = adCmdText
                                 .CommandText = strSQL
                                 .Execute
                              End With
                           End If
                        End If
                        .Close
                        Set rstTest = Nothing
                        Err.Clear
                        On Error GoTo 0
                        DoEvents
                     End With
                  End If
                  If blnHalt Then
                     Exit Do
                  End If
               Loop
               If blnHalt Then
                  Exit Do
               End If
               
               strPartURL = Replace$(strPartURL, "http://www.access.gpo.gov", "")
               strPartURL = Replace$(strPartURL, "_main_", "_")
               
               strChapHTML = Mid$(strChapHTML, InStr(strChapHTML, strPartURL) + Len(strPartURL) + 1)
               strChapHTML = Mid$(strChapHTML, InStr(strChapHTML, ">") + 1)
               
               DoEvents
               If Len(strText) > 100000 Then
                  'Dump the log text
                  strText = ""
               End If
            Loop
            If blnTitleDone Or blnHalt Or Len(strTitleHTML) < 50 Then
               'Zero-length test required for Title 42
               Exit Do
            End If
           
            strTemp = Mid$(strChapURL, InStr(strChapURL, "/nara"))
            If InStr(strTitleHTML, strTemp) Then
               strTitleHTML = Mid$(strTitleHTML, InStrRev(strTitleHTML, strTemp) + Len(strTemp) + 1)
               strTitleHTML = Mid$(strTitleHTML, InStr(strTitleHTML, ">") + 1)
            Else
               Stop
            End If
            DoEvents
         Loop
      End If
      If blnHalt Then
         Exit For
      End If
      DoEvents
      If Len(strText) > 100000 Then
         'Dump the log text
         strText = ""
      End If
   Next intTitle
   With rstTest
      'For safety
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstTest = Nothing
   Call ButtonState(True)
   If Len(strText) > 100 Then
      Call OpenFile(strText, "MissingItems.txt")
   Else
      txtDoc.Text = "No parts or sections were updated."
   End If
   Me.MousePointer = vbDefault
End Sub

Private Sub cmdStoreTOCs_Click()
   'Create TOCs for each (sub)title, (sub)chapter, and part
   'Persistent TOCs eliminate the need to generate the TOC for each client request
   'The cmdList_DblClick subprocedures generate the XML document
   'and update the TOCChar or TOCText field of the tables
   
   Dim intTitles As Integer
   Dim intChapters As Integer
   Dim intParts As Integer
   Dim strMsg As String
   
   strMsg = "Creating individual tables of contents for each title, " & _
      "chapter, and part increases the size of the database by about " & _
      "100 MB and takes about an hour to complete on a moderately fast " & _
      "computer. Make sure you have enough free disk space before proceeding." & _
      vbCrLf & vbCrLf & "If you haven't retrieved sections for all parts " & _
      "from pages in the eCFR database, they are retrieved during this " & _
      "process and the completion time increases." & vbCrLf & vbCrLf & "Click OK to continue. "
   If MsgBox(strMsg, vbOKCancel + vbInformation, "Create Persistent TOCs in the Database") = vbCancel Then
      Exit Sub
   End If
   
   Call ButtonState(False)
   cmdHalt.Enabled = True
   lstSections.Visible = False
   Me.MousePointer = vbHourglass
   
   blnAddTOC = True
   blnAttribs = True
   Call ButtonState(False)
   
   'Loop through the Titles, Chapters, and Parts lists
   With lstTitles
      .ListIndex = 0
      For intTitles = 0 To .ListCount - 1
         .ListIndex = intTitles
         DoEvents
         Call lstTitles_DblClick
         DoEvents
         With lstChapters
            .ListIndex = 0
            For intChapters = 0 To .ListCount - 1
               .ListIndex = intChapters
               If InStr(.List(.ListIndex), "has no chapters") = 0 Then
                  DoEvents
                  Call lstChapters_DblClick
                  DoEvents
                  With lstParts
                     .ListIndex = 0
                     For intParts = 0 To .ListCount - 1
                        .ListIndex = intParts
                        DoEvents
                        Call lstParts_DblClick
                        DoEvents
                        If blnHalt Then
                           Exit For
                        End If
                     Next intParts
                  End With
               Else
                  With lstParts
                     If .ListCount > 0 Then
                        .ListIndex = 0
                        For intParts = 0 To .ListCount - 1
                           .ListIndex = intParts
                           DoEvents
                           Call lstParts_DblClick
                           DoEvents
                           If blnHalt Then
                              Exit For
                           End If
                        Next intParts
                     End If
                  End With
               End If
               If blnHalt Then
                  Exit For
               End If
            Next intChapters
         End With
         If blnHalt Then
            Exit For
         End If
      Next intTitles
   End With
   blnHalt = False
   
   If chkAttribs.Value = 0 Then
      'Reset the attributes flag
      blnAttribs = False
   End If
   blnAddTOC = False
   Me.MousePointer = vbDefault
   Call ButtonState(True)
   cmdHalt.Enabled = False
   lstSections.Visible = True
End Sub

Private Sub cmdGetAllDocs_Click()
   'Start at the beginning of the TOC and attempt to retrieve
   'all missing documents (This takes a LONG time)
   Dim strTitleID As String
   Dim strPartID As String
   Dim strSectID As String
   Dim strSQL As String
   Dim strAppURL As String
   
   Dim intDocError As Integer
   Dim intCtr As Integer
   
   Dim blnFirstDoc As Boolean

   blnGetAllDocs = True
   blnFirstDoc = True
   Call ButtonState(False)
   
   txtDoc.Text = ""
   cmdGetAllDocs.Enabled = False
   cmdHalt.Enabled = True
   lstSections.Clear
   blnHalt = False
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   
   strSQL = "SELECT TitleID, PartID, SectionID, ParseError FROM Sections " & _
      "WHERE HasText = 0 ORDER BY TitleID, PartIDSort, SectionIDSort"
   
   'Temporary to skip doc not found
   strSQL = "SELECT TitleID, PartID, SectionID, ParseError FROM Sections " & _
      "WHERE (HasText = 0 or ParseError = 1) AND (DocNotFound = 0 OR DocNotFound IS NULL) ORDER BY TitleID, PartIDSort, SectionIDSort"
   
   'Temporary to skip parse errors for production
   strSQL = "SELECT TitleID, PartID, SectionID, SourceURL, ParseError FROM Sections " & _
      "WHERE (HasText = 0 AND ParseError IS NULL) AND (DocNotFound = 0 OR DocNotFound IS NULL) ORDER BY TitleID, PartIDSort, SectionIDSort"
      
   'Temporary to process appendices only
   'strSQL = "SELECT TitleID, PartID, SectionID, SourceURL, ParseError FROM Sections " & _
   '   "WHERE SourceURL IS NOT NULL ORDER BY TitleID, PartIDSort, SectionIDSort"
      
      
   With rstSections
      If .State = adStateOpen Then
         .Close
      End If
      Set .ActiveConnection = gcnnCFR
      .Source = strSQL
      .CursorLocation = adUseServer
      .CursorType = adOpenKeyset
      .LockType = adLockOptimistic
      .Open
   End With
   
   intDocError = 1
   With rstSections
      If .EOF Then
        'Needs a message re all sections have text
        Call ButtonState(True)
        cmdHalt.Enabled = False
        blnGetAllDocs = False
      End If
      .MoveFirst
      Do While Not .EOF
         strTitleID = CStr(.Fields(0).Value)
         strPartID = CStr(.Fields(1).Value)
         strSectID = CStr(.Fields(2).Value)
         If IsNull(.Fields(3).Value) Then
            strAppURL = ""
         Else
            'URL to retrieve appendices
            strAppURL = CStr(.Fields(3).Value)
         End If
         intDocError = UpdateSectionTextUI(strTitleID, strPartID, strSectID, strAppURL, blnFirstDoc)
         If intDocError = 0 Then
            blnFirstDoc = False
         End If
         If blnHalt Then
            blnHalt = False
            Me.MousePointer = vbDefault
            Exit Do
         End If
         .MoveNext
      Loop
   End With
   Call ButtonState(True)
   cmdHalt.Enabled = False
   blnGetAllDocs = False
End Sub

Private Sub cmdParseErrors_Click()
   'Start at the beginning of the TOC and attempt to retrieve
   'all missing documents (run overnight, because this takes a LONG time)
   Dim rstParse As New ADODB.Recordset
   Dim domParse As New MSXML2.DOMDocument30
   Dim strTitleID As String
   Dim strPartID As String
   Dim strSectID As String
   Dim strSQL As String
   Dim strDoc As String
   Dim lngLength As Long
   Dim intDocError As Integer
   
   Call ButtonState(False)
   
   txtDoc.Text = ""
   cmdGetAllDocs.Enabled = False
   cmdHalt.Enabled = True
   lstSections.Clear
   blnHalt = False
   lblDoc.Caption = strPartsLabel
   blnOpenInNotepad = False
   
   strSQL = "SELECT TitleID, PartID, SectionID, TextLength, ParseError FROM Sections " & _
      "WHERE ParseError = 1 ORDER BY TitleID, PartIDSort, SectionIDSort"
   
   With rstSections
      If .State = adStateOpen Then
         .Close
      End If
      Set .ActiveConnection = gcnnCFR
      .Source = strSQL
      .CursorLocation = adUseServer
      .CursorType = adOpenKeyset
      .LockType = adLockOptimistic
      .Open
   End With
   
   intDocError = 1
   With rstSections
      .MoveFirst
      Do While Not .EOF
         strTitleID = CStr(.Fields(0).Value)
         strPartID = CStr(.Fields(1).Value)
         strSectID = CStr(.Fields(2).Value)
         If Not IsNull(.Fields(3).Value) Then
            lngLength = CLng(.Fields(3).Value)
            If lngLength > 7000 Then
               strSQL = "SELECT SectText FROM Sections WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectID & "'"
            Else
               strSQL = "SELECT SectChar FROM Sections WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectID & "'"
            End If
            With rstParse
               If .State = adStateOpen Then
                  .Close
               End If
            End With
            Set rstParse = gcnnCFR.Execute(strSQL, , adCmdText)
            If Not rstParse.EOF Then
               strDoc = CStr(rstParse.Fields(0))
               With domParse
                  .loadXML strDoc
                  If .parseError <> 0 Then
                     rstSections.Fields(4) = True
                     rstSections.Update
                     Debug.Print strTitleID & "CFR" & strPartID & "." & strSectID & ": " & .parseError.reason
                     intDocError = intDocError + 1
                  End If
               End With
            End If
         End If
         DoEvents
         If blnHalt Then
            blnHalt = False
            Me.MousePointer = vbDefault
            Exit Do
         End If
         .MoveNext
      Loop
   End With
   Debug.Print "Total Parse Errors: " & intDocError
   Call ButtonState(True)
   cmdHalt.Enabled = False
   blnGetAllDocs = False
End Sub

Private Function UpdateSectionTextUI(ByVal strTitleID As String, _
                                     ByVal strPartID As String, _
                                     ByVal strSectID As String, _
                                     ByVal strAppURL As String, _
                                     ByVal blnFirstDoc As Boolean) As Integer
   'Calls the UpdateSectionText function and adds UI elements
   Dim strDoc As String
   Dim strItem As String
   
   Dim intDocError As Integer
   
   Dim sngTime As Single
   
   Me.MousePointer = vbHourglass
   cmdGetAllDocs.Enabled = False
   With lstSections
      If blnGetAllDocs Then
         strItem = "Retrieving " & strTitleID & "CFR" & strPartID & "." & strSectID
         .AddItem strItem
         .ListIndex = .ListCount - 1
      End If
      sngTime = Timer
      
      'Get the section text
      strDoc = clsGetSect.UpdateSectionText(gstrConnect, strTitleID, strPartID, strSectID, strAppURL, blnFirstDoc)
      
      sngTime = Timer - sngTime
      If Left$(strDoc, 1) = "<" Then
         strItem = "Retrieved " & strTitleID & "CFR" & strPartID & "." & strSectID & _
            " (" & CStr(Len(strDoc)) & " chars, " & CStr(Int(sngTime)) & " secs)"
         intDocError = 0
      Else
         strItem = "Error: " & strDoc
         intDocError = 1
      End If
      If blnGetAllDocs Then
         If InStr(strItem, vbCrLf) > 0 Then
            .List(.ListCount - 1) = Left$(strItem, InStr(strItem, vbCrLf) - 1)
         Else
            .List(.ListCount - 1) = strItem
         End If
         If InStr(strItem, "Error:") = 0 Then
            .Selected(.ListCount - 1) = True
         End If
      End If
      txtDoc.Text = strDoc
      If strDoc = "The request has timed out" Or InStr(strDoc, "Halted") > 0 Then
         txtDoc.Text = txtDoc.Text & vbCrLf & "(The eCFR server probably is shut down)"
         'blnHalt = True
      End If
   End With
   Me.MousePointer = vbDefault
   UpdateSectionTextUI = intDocError
End Function

Private Sub ButtonState(blnEnabled As Boolean)
   'Enable or disable all buttons
   cmdConnect.Enabled = blnEnabled
   cmdChapTOC.Enabled = blnEnabled
   cmdPartTOC.Enabled = blnEnabled
   chkAttribs.Enabled = blnEnabled
   cmdGetAllDocs.Enabled = blnEnabled
   cmdStoreTOCs.Enabled = blnEnabled
   cmdGetSects.Enabled = blnEnabled
   cmdClientForm.Enabled = blnEnabled
   cmdParseErrors.Enabled = blnEnabled
   cmdUpdates.Enabled = blnEnabled
End Sub

Private Sub CloseAllADO(blnCloseConnection As Boolean)
   'Close all Recordsets (set to Nothing by VB.NET GC)
   With rstCFRText
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstCFRText = Nothing
   With rstTitles
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstTitles = Nothing
   With rstSubtitles
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstSubtitles = Nothing
   With rstChapters
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstChapters = Nothing
   With rstSubchapters
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstSubchapters = Nothing
   With rstGroupsAndParts
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstGroupsAndParts = Nothing
   With rstParts
      If .State = adStateOpen Then
         .Close
      End If
   End With
   With rstSections
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstSections = Nothing
   If blnCloseConnection Then
      'Close the connection
      With gcnnCFR
         If .State = adStateOpen Then
            .Close
         End If
      End With
      Set gcnnCFR = Nothing
   End If
   lstTitles.Clear
   lstChapters.Clear
   lstParts.Clear
   lstSections.Clear
   txtDoc.Text = ""
End Sub

Private Sub Form_Unload(Cancel As Integer)
   'Clean up and kill it
   Set clsGetSect = Nothing
   Set clsUpdates = Nothing
   Call CloseAllADO(True)
   End
End Sub

