<%@ LANGUAGE="VBSCRIPT" ENABLESESSIONSTATE = False %>

<%
'****************************************************************
'Returns specified tables of contents from virtual directory \CFR
'The virtual directory points to the CFRClient application folder
'Copyright (c) 2001 Roger Jennings - All Rights Reserved
'****************************************************************

'Open the specified TOC with the GetTOCByID Function
'GetTocById(strConnect, strURL, strTOCType, strId)
'A typical TOC ID is ti7stA (returns parts)
'URL is: http://localhost/cfr/opentoc.asp?TocID=ti7stA

'If the TOC is at the section level, retrieve the text
'GetSectById(strConnect As String, strDocType, strId)
'A typical section ID is: ti21st-ch1scBpn101sn9
'URL is: http://localhost/cfr/opentoc.asp?TocID=ti21st-ch1scBpn101sn9

Option Explicit
Response.Buffer = True
Response.Expires = 0

Dim strID, cfrTOC, cfrSect, strConnect, strXHTML
strConnect = Application("strConnect")

strID = Request.QueryString("TocID")
If strID = "" then
   'Default to titles
   strID = "ti0"
End If

If InStr(strID, "sn") > 0 Then
   'Retrieve the section text
   Server.ScriptTimeout = 300
   Set cfrSect = CreateObject("CCFRSect.CFRSect")
   strXHTML = cfrSect.GetSectById(strConnect, "XHTML", strID)
   Server.ScriptTimeout = 90
   Set cfrSect = Nothing
Else
   'Retrieve the TOC by level
   Set cfrTOC = CreateObject("CCFRToc.CFRToc")
   strXHTML = cfrTOC.GetTocById(strConnect, "", "XHTML", strID)
   If Len(strXHTML) < 500 Then
      'Returned an error string
      If InStr(strXHTML, "ERROR: Table of contents missing") > 0 then
         'Try subtitles if no chapter specified
         If InStr(strID, "ch") = 0 then
            'Try the first subtitle
            strID = Replace(strID, "st_", "")
            strID = strID & "stA"
            strXHTML = cfrTOC.GetTocById(strConnect, "", "XHTML", strID)
            If Len(strXHTML) < 500 Then
               'Try subtitle B (for title 41, which doesn't have a subtitle A
               strID = Replace(strID, "stA", "stB")
               strXHTML = cfrTOC.GetTocById(strConnect, "", "XHTML", strID)
            End If
         End If
      End If
   End If
   Set cfrTOC = Nothing
End If

'Open the XHTML document
Response.write strXHTML
%>