<%@ LANGUAGE="VBSCRIPT" ENABLESESSIONSTATE = False %>

<%
'****************************************************************
'Returns full-text search results from virtual directory \CFR
'The virtual directory points to the CFRClient application folder
'Copyright (c) 2001 Roger Jennings - All Rights Reserved
'****************************************************************

'Return XHTML search results with the GetSearchResults function of CCFRSearch.CFRSearch
'GetSearchResults(strConnect, 
'                 strSearch, 
'                 intMaxHits, 
'                 intMinLevel, 
'                 intMaxLevel, 
'                 strTitleID,
'                 lngTOCItems,
'                 lngSectItems,
'                 strSearchType)

'A typical search string with a GET operation is 
'http://localhost/cfr/search.asp?Term=department+NEAR+agriculture&
'                                InTOC=on&
'                                InSect=on&
'                                Title=%A0%A07+-+Agriculture&
'                                Level=Subchapters&
'                                MaxHits=50

Option Explicit
Response.Buffer = True
Response.Expires = 0

Dim strConnect, strSearch, intMaxHits, intMinLevel, intMaxLevel
Dim strTitleID, lngTOCItems, lngSectItems, strSearchType, strXHTML
Dim strLevel, strInTOC, strInSect, cfrSearch

strConnect = Application("strConnect")

'Get the lngTOCItems and lngSectItems values from FTStats.inc (see Search.asp)
%>
<!--#include File="FTStats.inc" -->
<%

strSearch = Request.QueryString("Term")
If Len(strSearch) > 0 Then
   strSearch = Replace(strSearch, "+", " ")
Else

End If

'Get the maximum number of elements to return
intMaxHits = Request.QueryString("MaxHits")

'Set the maximum and minimum search levels
'For the logic of the minimum and maximum levels, see the cmdSearch_Click handler of frmClientEmulator
strLevel = Request.QueryString("Level")
Select Case strLevel
   Case "Parts"
      intMaxLevel = 6
   Case "Subchapters"
      intMaxLevel = 5
   Case "Chapters"
      intMaxLevel = 4
   Case "Subtitles"
      intMaxLevel = 3
   Case "Titles"
      intMaxLevel = 2
End Select

strInTOC = Request.QueryString("InTOC")
strInSect = Request.QueryString("InSect")

intMinLevel = 0
If strInSect = "on" Then
   'TOC and section text search
   intMaxLevel = 7
End If

If strInSect = "on" And strInTOC = "" Then
   'Only section text search
   intMinLevel = 7
End If

'Get the TitleID
strTitleID = Request.QueryString("Title")
strTitleID = Replace(strTitleID, "%AO","")
strTitleID = Left(strTitleID, InStr(strTitleID, " ") - 1)
If strTitleID = "All" Then
   'Empty string returns results from all titles
   strTitleID = ""
End If

Set cfrSearch = CreateObject("CCFRSearch.CFRSearch")
strXHTML = cfrSearch.GetSearchResults(strConnect, strSearch, intMaxHits, intMinLevel, intMaxLevel, strTitleID, lngTOCItems, lngSectItems, "XHTML")
Set cfrSearch = Nothing

'Open the XHTML document
Response.write strXHTML
%>